;------------------------------------------------------------------------------------------------
;  Net2BBS Telnet Server
;  Version 1.20b9
;  Written by Mike Ehlert - PC Micro Systems, Inc. 
;  http://pcmicro.com/netfoss
;  Released to the Public Domain as Licenced Open Source Code.
;  Read Net2BBS.txt for license details.
; 
;  Assemble in MASM32, using Qeditor > Project > "Console Assemble and Link"
;  or link using Polink.exe for optimum file size. Assemble under Windows 10.
;------------------------------------------------------------------------------------------------
.586
.model flat,stdcall

;===============
service equ TRUE  ; TRUE=compile with service functions, FALSE=compile without
;===============  ; The EXE will be about 1k smaller when set for FALSE

option casemap:none
   include \masm32\include\windows.inc	; Windows
   include \masm32\include\user32.inc	; User
   include \masm32\include\kernel32.inc	; Kernel
   include \masm32\include\ws2_32.inc	; Winsock 2.0
   include \masm32\include\winmm.inc	; MultiMedia play functions
   include \masm32\include\masm32.inc	; MASM32
   include \masm32\macros\macros.asm	; MASM32 Macros
   include \masm32\include\advapi32.inc	; Services

   includelib \masm32\lib\user32.lib	; User
   includelib \masm32\lib\kernel32.lib	; Kernel
   includelib \masm32\lib\ws2_32.lib	; WinSock 2.0
   includelib \masm32\lib\winmm.lib 	; MultiMedia play functions
   includelib \masm32\lib\masm32.lib	; MASM32
   includelib \masm32\lib\msvcrt.lib	; C library (only used for getkey)
if service
   includelib \masm32\lib\advapi32.lib	; Services
endif

   StartServer       proto
   AcceptThread      proto
   AcceptThread2     proto
   LockLog           proto
   AddIPtoCache      proto
   BindListen        proto :DWORD
   SpawnNodeThread   proto :DWORD
   GetAppPath        proto :DWORD
   ReadMyFile        proto :DWORD    
   PlayWav           proto :DWORD
   SetTextColor      proto :BYTE
   ServiceMsgHandler proto :DWORD
   Shell             proto :DWORD,:DWORD,:DWORD
   GetFromIni        proto :DWORD,:DWORD,:DWORD,:DWORD
   WriteLog          proto :DWORD,:DWORD
   WriteLog2         proto :DWORD,:DWORD,:DWORD,:DWORD,:BYTE
   WriteLog3         proto :DWORD,:DWORD,:DWORD,:DWORD,:BYTE
   WriteLogFlush     proto
   LogRefused        proto :DWORD,:DWORD
   LogBlocked        proto :DWORD,:DWORD
   Replace           proto :DWORD,:DWORD,:DWORD,:DWORD	
   ReadLine          proto :DWORD,:DWORD,:DWORD
   WildMatch         proto :DWORD,:DWORD
   WebClient         proto :DWORD,:DWORD,:DWORD,:DWORD
   My_ntop           proto :PTR,:PTR
   
   proto_Pinet_ntop typedef proto stdcall :WORD,:PTR,:PTR,:DWORD
   Pinet_ntop       typedef ptr proto_Pinet_ntop   
;----------------------
; Console Color Codes:
BLACK         equ 0
DARK_BLUE     equ 1
DARK_GREEN    equ 2
DARK_CYAN     equ 3
DARK_RED      equ 4
DARK_PURPLE   equ 5
DARK_YELLOW   equ 6
DARK_WHITE    equ 7
DARK_GRAY     equ 8
BRIGHT_BLUE   equ 9
BRIGHT_GREEN  equ 10
BRIGHT_CYAN   equ 11

BRIGHT_RED    equ 12
BRIGHT_PURPLE equ 13
BRIGHT_YELLOW equ 14
WHITE         equ 15
;----------------------

.data
align 4

if service
   ServiceTable    dd  offset ServiceName, offset ServiceMain, 0, 0 ; Service Control Table
endif

BlockValue dd 1 ; (0) blocking or (1) non-blocking
   MinuteCounter   dd   0			; Number of minutes that Net2BBS has been running
   QuartMinCounter dd   0
   null            dd   0			; zero binary doubleword	   
   zero            db   "0",0			; zero ascii string
   one             db   "1",0			; one  ascii string
   BlockMode       dd   1				; 0=Blocking, 1=None Blocking
   WSTimeOut       dd   1050			; Winsock Send/Receive Timeout
   _addr4xsize     dd   SIZEOF _addr4x		; The size of our winsock listen/accept info buffer
   _addrx          dd 0 ;addr _addr4x
   _addrxsize      dd 0 
   _addrx_sin_addr dd 0 ; addr _addr6x.sin6_addr ; Assume IPv6
   TimerParam1      dd   123			; The ID of our timer
   TimerParam2      dd   124			; The ID of our timer
   logbytes         dd  0 ; size of writelog buffer3
 
   fMtString        db  "%lu",0			; Format string mode used by wsprintf
   ;ClassName       db  "ConsoleWindowClass",0
   Net2BBSTitle     db  "Net2BBS "
   TelnetSrvTxt     db  "Telnet Server",0
   VersionTxt       db  " 1.20", 225,"9",0 ;
   PolicySrvTxt     db  "Socket Policy Server",0
   IniFileName      db  "net2bbs.ini",0
   IniFileNameFill  db  20 dup (0)
   CountryCodeFile  db  "countrycodes.txt",0
   HelpFileName     db  "net2bbs.txt",0
   IniSectionName   db  "Settings", 0	; [Settings] is our .INI Section
   DateTxt          db  "00-00-0000 "	; Date Format for WriteLog
   TimeTxt          db  "00:00:00"		; Time Format for WriteLog
   DotSlash         db  "./",0		; Default StartPath
   WebGeoIPFlag     db  0                    ; Enable if countrycodes.txt has blocked countries
   Dec_ActiveNodes db  0
   SockEnvVar       db  "SOCKET",0    ; Name of Environment Variable to store socket Handle
   NodeEnvVar       db  "NFNODE",0    ; Name of Environmemt Variable to store NetFoss Node (Needed for pseudo nodes and NFU)
   IPWhiteList      dd  16 dup (0)   ; List of 4 IP's always allowed to connect (127.0.0.1=0100007Fh)
   ECHOCMD          db  255,251,1,8,8," "," ",8,8,8 ;  Enable telnet echo

;   website	    db "freegeoip.net",0 ; Web Site to use for GeoIP country lookup (if countrycodes.txt exists)

ReqCommand   db "GET ",0
ReqFolder    db "/xml/",0
;ReqIP       db 64 dup (0) ;
ReqHTTP      db " HTTP/1.1",13,10,0
ReqAgent     db 0 ; was "User-Agent: ",0
            ;db "User-Agent: Mozilla/5.0 (Windows NT 6.3; WOW64; Trident/7.0; rv:11.0) like Gecko",13,10
            ;db "User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; nl; rv:1.8.0.3)",13,10

ReqUserHost  db "Host: ",0

;ReqHostName  ; "freegeoip.net"
;             db 13,10 
;             db "Accept: */*",13,10 ; not required
ReqClose      db 13,10,"Connection: close",13,10,13,10,0
            
XML_CC     db "<CountryCode>",0
XML_CN     db "<CountryName>",0


; Log file messages:

   WaitingTxt      db  "Listening for ",0
   TelnetTxt       db  "Telnet",0
   PolicyTxt       db  "Socket Policy",0
   ConnectionsTxt  db  " connections"
   OnPortTxt       db  " on port ",0
   ErrorTxt        db  "Error starting ",0
   Node_           db  "Node ",0
   LoginTxt        db  " login: ",0
   WhiteListedTxt  db  "WhiteList ",0
   IPTxt           db  "IP: ",0
   ResolvedTxt     db  "Hostname: ",0
   UnknownTxt      db  "Unknown",0
   OpenedTxt       db  " opened.",0
   ClosedTxt       db  " closed.",0

   RefusedTxt      db  "Connection Refused (",0
   Refused0Txt     db  "Already Connected)",0
   Refused1Txt     db  "All Nodes in use)",0 
   Refused2Txt     db  "Semaphore exists)",0 
   Refused3Txt     db  "Matched kill list)",0
   Refused4Txt     db  "Portscanner detected)",0

   BlockedTxt      db  " Blocked (",0
   Blocked1Txt     db  "Cached IP)",0
   Blocked2Txt     db  "Hammering)",0
   Blocked3Txt     db  "Under Attack)",0   

   MissingTxt      db  "Missing ",0         ; Log message when missing socket policy
   SendPolicyTxt   db  "Sent "              ; Log message when sending socket policy 
   PolicyFileName  db  "SocketPolicy.xml",0 ; Socket Policy FileName
   StoppingTxt     db  "Shutting down.",0   ; Log message when exiting
   BBSTitle        db  "BBS node "          ; The Title of an active BBS node window
   BBSTitleNode    db   "   ",0             ; Room to add the node number
   BUSYtxt         db  "BUSY",13,10         ; Send this to client when all nodes are in use
   LogonWav        db  "logon.wav",0        ; Play this sound during a new logon (if it exists)
   LogoffWav       db  "logoff.wav",0       ; Play this sound during a logoff (if it exists)
   DNSBLTxt        db  "DNSBL:"          ; DNS Blacklist checker (uses spacestring below)
   spacestring     db  " ",0                ; string spacer
   PassedTxt       db  " (passed)",0        ; DNS BL Passed result.
   ListedTxt       db  " (listed)",0        ; DNS BL Listed result.
   PreCCTxt        db  " ("                 ; must be above the Country Code line!
   CountryCodeTxt  db  "000=paxxed)",0,0    ; ISO 3166 Country Code (and extra string space)
   PostCCTxt       db  "=",0                ; Text placed after CC number
   GeoIPTxt        db  "GeoIP: ",0          ; US - United States
   GeoDash         db  "-",0
   CRLFLFLF        db  10
   CRLFLF          db  10
   CRLF            db  10,13,0

;  ANSIClear       db  01Bh,"[2J"		; ANSI command to clear the remote screen
   HitEscAgainTxt  db  10,10,10,10,10,9,"Press [ESC] to exit [R] to restart, or any other key to resume."
   mailslot        db  "\\.\mailslot\net2bbs",0 ;  mailslot to send service messages to the monitor 
   RestartFlag     db  0 ; Flag enabled during a restart only 
   ServiceFlag     db  0 ; Flag enabled when started with /s parameter (Service Mode)

   ntext           db  "*n",0	; Command Line Macro to replace with Node value    (must be lower case here)
   ztext           db  "*z",0 ; Command Line Macro to replace with Node-Startnode+1
   htext           db  "*h",0	; Command Line Macro to replace with Handle value  (must be lower case here)  
   IPtext          db  "*i",0	; Command Line Macro to replace with IP Address    (must be lower case here)
   restext         db  "*r"	; Command Line Macro to replace with resolved name (must be lower case here)   
   ServiceName     db  0	; Service name can be blank for SERVICE_WIN32_OWN_PROCESS 
   hextable db "0123456789ABCDEF" ; For hex conversion

   _addr4size dd SIZEOF _addr4
   _addr6size dd SIZEOF _addr6
   _addr6xsize dd SIZEOF _addr6x
   
   AF_type         dw AF_INET6   
   ws2_32      db "ws2_32.dll",0
   inetntop    db "inet_ntop",0

.data?
align 4
   TCPport         dd ?			; Default Telnet TCP port = 23   
   GeoIPWebPort    dd ?         ; Default GeoIP web port  = 80
   PolicyPort      dd ?			; Default Policy Port is disabled. Set to 843 to enable
   StartNode       dd ?			; First Telnet node to use
   MaxNodes        dd ?			; Maximum number of Telnet nodes
   LastNode        dd ?			; Last node number (startnode+maxnodes-1)
   INI_ADDR        dd ?			; Address of NET2BBS.INI
   hWnd            dd ?			; Handle of Console Window
;  hStdIn          dd ?			; Handle of Standard Input - not used
   hStdOut         dd ?			; Handle of Standard Output - Needed for Color text 
   hInSock         dd ?			; Handle of Incoming Telnet Socket
   hInSock2        dd ?			; Handle of Incoming Policy Socket
   hSock2          dd ?			; Handle of Actual Policy Socket			
   hLogFile        dd ?			; Handle of the Log File
   hServiceStatus  dd ?			; Handle to status info structure for the service
   ThreadID        dd ?			; Thread ID is not used currently (write only)
   StopEvent       dd ?			; Event to signal shutdown in progress
   written         dd ?			; Bytes written to log file - Not currently used (write only)
   HelpY           dd ?			; Y position of the help line on the Console screen
   CachePtr        dd ?       ; Pointer to next position in Cache
   CacheTime       dd ?
   CacheLock       dd ?       ; Write-Lock device for Cache  - 1=locked
   HistLock        dd ?       ; History lock for shifting data 1=locked
   LogLock         dd ?       ; Log file lock for writing -    1=locked
   MaxSameIP       dd ?       ; Maximum number of same IP's allowed conected
   AntiHammer      dd ?       ; AntiHammer Enable Flag - 0 or 1.
   AntiScanner     dd ?       ; AntiScanner Enable Flag - 0 or 1.
   dual_stack      dd ?
   _inet_ntop      Pinet_ntop ?       ; address of inet_ntop function (only in Vista or later)

   NodeTable       dd 256*4 dup (?) ; This table defines which nodes are in use(non-zero) or inactive(0).
   DenyCache       dd 128*4 dup (?) ; Table of cached IP's to deny
   DenyCacheTime   dd 128   dup (?) ; Table of cached IP's timestamp
   HistoryCache    dd 64*4  dup (?) ; Table of cached IP's that recently connected
   HistoryCount    dd 64  dup (?) ; Table of hits by cached IP's that recently connected
   
tempnode dd ? ;!!!!!!

   LogBuf          db 128 dup (?) ; Buffer used for current log line
   LogBuf2         db 128 dup (?) ; Secondary Log buffer (used by writelog only)
   LogBuf3         db 2048 dup (?); Third Log buffer (used by writelog only)

   CommandTxt      db 128 dup (?) ; Spawn Command line provided in INI
   StartPath       db 128 dup (?) ; Node Start Path provided in INI
   KillFileName    db 128 dup (?) ; List of blocked IP's
   KillMsg         db 128 dup (?) ; Text to show a blocked IP
   KillMsgFileName db 128 dup (?) ; Kill Message FileName
   EditorName      db 256 dup (?) ; Editor Filename + space + path to Net2BBS\
   EditorCmd       db 256 dup (?) ; Editor Filename + space + path to Net2BBS\filename to open
   LogFileName     db 128 dup (?) ; Log FileName
   SemFileName     db 128 dup (?) ; Semaphore FileName
   ResolveMsg      db 128 dup (?) ; Message shown to user at connect (if Resolve enabled)
   DotTxt          db ?
   DNSBL           db 31  dup (?) ; DNS Blacklist URL - passed by .ini file 
   DotTxt2         db ?
   DNSBL2          db 31  dup (?) ;
   DotTxt3         db ?
   DNSBL3          db 31  dup (?) ;
   DotTxt4         db ?
   DNSBL4          db 31  dup (?) ;
   BlockCCTxt      db 128 dup (?) ; ascii list of blocked Country Codes
   BlockCC         db 512 dup (?) ; binary list of blocked Country Codes (either format)
   WhiteListTxt    db 64  dup (?) ; ascii WhiteList of up to 4 IP Addresses, comma delimited (no wildcards)
   GeoIPWebTxt     db 64  dup (?) ; GeoIP Web site
   GeoIPPortTxt    db 8   dup (?)
;=============== These need to stay in this order, as all are sent to the MailSlot at the same time
   MailSlotColor   db ?            ; Color passed to MailSlot
   MailSlotSound   db ?            ; Sound passed to MailSlot
   LaunchSpyNode   db ?
   ActiveNodes     db ?		     ; Number of currently active nodes
;===============
   TCPportTxt      db   8 dup (?) ; Ascii text of the TCP port (default 23)
   PolicyPortTxt   db   8 dup (?) ; Ascii text of the Policy port (default 0 = disabled. Set to 843 to enable)
   StartNodeTxt    db   4 dup (?) ; Ascii text of the first telnet node number
   MaxNodesTxt     db   4 dup (?) ; Ascii text of the maximum number of telnet connections
   MaxSameIPTxt    db   4 dup (?) ; Ascii text of the maximum connections allowed per IP Address
   NodeLinesTxt    db   4 dup (?) ; Ascii text of the number of lines in the node window (25 or 50)
   DebugModeTxt    db   2 dup (?) ; Ascii "0"=disable, "1"=enable - Display debug messages 
   ResolveModeTxt  db   2 dup (?) ; Ascii "0"=disable, "1"=enable - Resolve IP address to hostname 
   ShowHostTxt     db   6 dup (?) ; Ascii text of the ShowHost mode for showing caller their hostname
   NodeViewTxt     db   3 dup (?) ; Ascii text of the showWindow mode for node windows
   MainViewTxt     db   3 dup (?) ; Ascii text of the ShowWindow mode for this window
   CacheTimeTxt    db   6 dup (?) ; Ascii time for Denied IP Cache to expire in Minutes.
   AntiHammerTxt   db   2 dup (?) ; Ascii "0"=disable, "1"=enable - AntiHammer protection.
   AntiScannerTxt  db   2 dup (?) ; Ascii "0"=disable, "1"=enable - AntiHammer protection.
   BlockingTxt     db   2 dup (?) ; Ascii "0"=non-block, "1"=blocking sockets
   NodeView        db          ?  ; Node ShowWindow view. Default = 1 (Normal)
   temp            dd          ?  ; Temporary dword used by FillConsoleOutputAttribute
   waitread_count  db ?
   lastchar        db ?
   readbuf         db 3 dup (?)
   phNewTimer  PHANDLE ?
   phLogTimer  PHANDLE ?
   timerflag1      db  ? ; used to skip first timer call
   timerflag2      db  ? ; used to skip first timer call

   ;count           db  ?
   ;counter         db  ?
;---------------------------------- for ipv6
   hostname    db 1024 dup (?)
   servicename db 32 dup (?) ; service name (or number)
   IPbuffer    db 46 dup (?) ; buffer to print Ansi text IP address
   bufsize     dd ?
;----------------------------------

; Data structures:

   SysTime SYSTEMTIME  <?>		; Used by GetLocalTime
   sinfo_   STARTUPINFO <?>		; Used for shell
   pinfo_   PROCESS_INFORMATION <?> ; Used for shell
   wsadata  WSADATA      <?>		; Winsock data structure
   _addr4  sockaddr_in   <?>		; Winsock primary   sockaddress_inbound structure
   _addr4x sockaddr_in   <?>		; Winsock secondary sockaddress_inbound structure
   _addr6  sockaddr_in6  <?>		; Winsock primary   sockaddress_inbound structure
   _addr6x  sockaddr_in6 <?>		; Winsock secondary sockaddress_inbound structure

  SOCKADDR_IN6 STRUCT
    sin6_family WORD ?
    sin6_port   WORD ?
    sin6_flowinfo DWORD ?
    sin6_addr  db 16 dup (?)
    sin6_scope_id DWORD ?
  SOCKADDR_IN6 ENDS

;ReqIP        db 64 dup (?) ;
   

   ;wsaRemoteEvents  WSANETWORKEVENTS <?> ; WinSock Events Data Structure
   SO_SNDTIME0 equ 3002h
   csbi CONSOLE_SCREEN_BUFFER_INFO <> ; Structure used for Console screen positioning
   ;DataBuf WSABUF <?>

if service
   status   SERVICE_STATUS <?>	; Used for Service Status      
endif

; For reading console keyboard without using msvcrt
;_INPUT_RECORD STRUCT
;	 EventType   WORD ?
;	 WORD ? 		   ; For alignment
;	 UNION
;	     KeyEvent		   KEY_EVENT_RECORD	     <>
;	     MouseEvent		   MOUSE_EVENT_RECORD	     <>
;	     WindowBufferSizeEvent WINDOW_BUFFER_SIZE_RECORD <>
;	     MenuEvent		   MENU_EVENT_RECORD	     <>
;	     FocusEvent		   FOCUS_EVENT_RECORD	     <>
;	   ENDS
;_INPUT_RECORD ENDS


;------------------------------------------------------------------------------------------------
.code

start:

; The EXE can run either as an Application or as a Service.	
; First check if a command line parameter has been passed. If so, check
; if it is "/s" which indicates that it's running as a service.
; If the service is active, then call startservice instead of startserver

	invoke ArgClC,1,ADDR EditorCmd
	cmp al,0
	je Application
        
if service

	mov ax, word ptr EditorCmd
	or ah,020h
	cmp ax,'s/' ; check for '/s' being passed as first Command Line parameter.
	jne CheckINI



ServiceStart:

	invoke	AllocConsole ; This is only needed if running as a service.
	inc ServiceFlag
	invoke StartServiceCtrlDispatcher, offset ServiceTable ; http://msdn.microsoft.com/en-us/library/ms686324(VS.85).aspx
	jmp short exitproc

endif ; service


CheckINI:
; A command line parameter was passed to the Application. Send it to IniFileName.

	cmp al,0
	je Application
	mov EditorCmd+32,0 ; truncate anything longer then 32 characters
	invoke lstrcpy, ADDR IniFileName, ADDR EditorCmd	; Append the Ini FileName to the INI path 	   

Application:
	invoke StartServer

exitproc:
	invoke ExitProcess,0


if service
;-------------------------------------------------------------------------------------------------------------------------------
SetStatus proc near State:dword, CheckPoint:dword, WaitHint:dword

; Set the Service Status

	mov eax,State
	mov status.dwCurrentState, eax
	mov status.dwWin32ExitCode, NO_ERROR 
	mov status.dwServiceSpecificExitCode, 0
	mov eax,CheckPoint
	mov status.dwCheckPoint, eax      ; increment for every subsequent START_PENDING update to reset time-out
	mov eax,WaitHint
	mov status.dwWaitHint, eax        ; time-out for next operation and subsequent call to SetServiceStatus
	invoke SetServiceStatus,hServiceStatus, offset status  ; http://msdn.microsoft.com/en-us/library/ms686241(VS.85).aspx
	ret
SetStatus endp

;-------------------------------------------------------------------------------------------------------------------------------
ServiceMain proc 	ArgC:dword,ArgV:dword

; Service Main

	invoke RegisterServiceCtrlHandlerEx, offset ServiceName, offset ServiceMsgHandler, 0
	mov hServiceStatus,eax

	; Initialize ServiceStatus structure

	mov status.dwServiceType, SERVICE_WIN32_OWN_PROCESS
	mov status.dwControlsAccepted, SERVICE_ACCEPT_SHUTDOWN + SERVICE_ACCEPT_STOP ; + SERVICE_ACCEPT_PARAMCHANGE                                                              ; SERVICE_ACCEPT_PAUSE_CONTINUE 
	invoke SetStatus, SERVICE_START_PENDING, 0, 2000

; Start the telnet server in a new thread!
	xor eax,eax	
	invoke CreateThread,eax,eax,offset StartServer,eax,eax,addr ThreadID ; hStartServerThread
	invoke CloseHandle,eax
	xor eax,eax
	invoke SetStatus, SERVICE_RUNNING, eax, eax
	
waitforstop:
	invoke Sleep,100	; allow time for service to create StopEvent
	invoke WaitForSingleObject, StopEvent, INFINITE
	cmp RestartFlag,0		; Don't exit if a restart command was performed
	jne waitforstop
	call ShutDown		; Tell all nodes to shutdown
	invoke WSACleanup		; Cleanup Winsock
	xor eax,eax
	invoke SetStatus, SERVICE_STOPPED, eax, eax
	ret
ServiceMain endp

;-------------------------------------------------------------------------------------------------------------------------------
ServiceMsgHandler proc near CtrlCode:DWORD

; This can check the following Service ControlCodes:
;
; SERVICE_CONTROL_STOP        requires SERVICE_ACCEPT_STOP
; SERVICE_CONTROL_SHUTDOWN    requires SERVICE_ACCEPT_SHUTDOWN
; SERVICE_CONTROL_PAUSE       requires SERVICE_ACCEPT_PAUSE_CONTINUE
; SERVICE_CONTROL_CONTINUE    requires SERVICE_ACCEPT_PAUSE_CONTINUE
; SERVICE_CONTROL_PARAMCHANGE requires SERVICE_ACCEPT_PAUSE_CONTINUE and SERVICE_ACCEPT_PARAMCHANGE

	mov eax,CtrlCode
	cmp eax,SERVICE_CONTROL_STOP
	je STOP

	cmp eax, SERVICE_CONTROL_SHUTDOWN
	jne SMH_exit

STOP:
	;------------------------------------------------
	; Update the service status and turn on StopEvent
 
	invoke SetStatus, SERVICE_STOP_PENDING, 1, 5000
	invoke SetEvent, StopEvent		; Tell all nodes and threads to shut down

SMH_exit:
	ret

ServiceMsgHandler endp

endif ; service

;-------------------------------------------------------------------------------------------------------------------------------
My_ntop proc near NTOP_addr:PTR, NTOP_textbuf:PTR


; My_ntop converts any IP address into its text format
; Invoke with pointer to IPAddress and location of text buffer
; The text buffer may be up to 40 characters.

; Returns with EAX=0 if the address is 32-bit format
; Returns with EAX=1 if the address is 128-bit format

	push ebx

; Convert Binary IP Address to text

	.if (dual_stack!=0) ;
		invoke _inet_ntop,AF_INET6, NTOP_addr, NTOP_textbuf, 40
		; Check if IP address starts with "00000000 00000000 0000FFFF"
		mov ebx,NTOP_addr
		mov eax, [ebx]
		or eax,  [ebx] +4
		jnz notip32        ; are first 2 dwords both zero?
		mov eax,[ebx]+8
		cmp eax,0FFFF0000h ; if so, check third dword
		jne notip32
		mov eax,NTOP_textbuf ; if it's 32-bit, delete first 7 characters of NT_textbuf
		mov ebx,eax
		add eax,7
		invoke lstrcpy,ebx, eax
	.else
		mov ebx,NTOP_addr 
		mov eax, [ebx+12]               ; get 32-bit IP
		invoke inet_ntoa,eax            ; Convert Internet Host Addr to dotted IP Addr
		invoke lstrcpy,NTOP_textbuf, eax  ; copy text to proper buffer
               jmp short gotip32
	.endif
gotip32:
		mov eax,1
		pop ebx
		ret
notip32:
		xor eax,eax
		pop ebx
		ret

My_ntop endp


;------------------------------------------------------------------------------------------------

TimerProc proc lpParam:PVOID, TimerOrWaitFired:DWORD
cld
; every 15 seconds, shift any active IP hit counters to the left by 4 bits

; Each active IP has a DWORD associated with it for it's history

	cmp timerflag1,0 ; always skip the first timer call
	mov timerflag1,1
	je  TimerExit 

	mov eax,AntiHammer
	test eax,eax
;jmp CheckTimer
	jz CheckTimer ; skip the shift if AntiHammer is disabled

	call LockHistory ; prevent history data access by other threads
	mov ecx, sizeof HistoryCount-4
        xor eax,eax
ShiftHistory:

       mov eax, dword ptr HistoryCount[ecx]
       test eax,eax
       jz nexthistory
	shl dword ptr HistoryCount[ecx],4   ; Shift the history count bits by 4
	jnz notzero

;pusha
;print "ShiftHistory shift resulted in erasing an IP from history",13,10
;popa

push ecx ;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        
        shl ecx,2 ; x4

    lea     edi,HistoryCache
    add     edi,ecx
    xor     eax,eax
    mov     ecx,4
    cld
    rep     stosd


	;mov HistoryCache[ebx],eax    ; Zero the IP address
	;mov HistoryCache[ebx+4],eax  ; Zero the IP address
	;mov HistoryCache[ebx+8],eax  ; Zero the IP address
	;mov HistoryCache[ebx+12],eax ; Zero the IP address
pop ecx

notzero:
nexthistory:
	sub ecx,4              ; otherwise check next one
	jns ShiftHistory
	xor eax,eax
	mov HistLock,eax ; Unlock the History for other threads to use

CheckTimer:    ; Now History has been shifted by 4 bits, increment Quarter Minute Counter

	inc QuartMinCounter
	cmp QuartMinCounter,4
	jne TimerExit
	mov QuartMinCounter,0
;----------------------------------------------------------------------------------------
	inc MinuteCounter     ; The following code will be run once per minute


mov eax,CacheTime
test eax,eax
jnz noskipclean
;pusha
;print "CacheTime=0",13,10
;popa

jmp skipclean

noskipclean:
;pusha
;print "Cleaning DenyCache",13,10
;popa

; there are 1440 minutes in a day.
;  every minute, scan the list of cached ip's to see if any have expired.
; they expire after xx (60?) minutes.
; zero the expired cache.

	xor edx,edx ; start at first entry

cleancache:

	mov ecx,edx
	shr ecx,2 ; convert from 128bit to 32bit (1 dword)

	mov eax,DenyCacheTime[ecx]
	test eax,eax              ; is it empty?
	jz  nextcache             ; skip if not

;pusha
;print "checking dword #"
;popa
;pusha
;print uhex$(edx)
;print "="
;popa
;pusha
;print uhex$(eax)
;print" min="
;mov eax,MinuteCounter
;print uhex$(eax)
;popa

	cmp eax,MinuteCounter
	jb  prenextcache ; was jb! ;!!!!!!!!!!! changed to jne in the 1.18 release

;pusha
;print " -clearing"
;popa

; Clear the Deny Cache

	;lea     edi,DenyCache
	;mov     ecx,edx
	;shl     ecx,2 ; x16 (leave at 2 since it was already x4, so result is 16)
	;add     edi,edx
	;xor     eax,eax
	;mov     ecx,4
	;rep     stosd

	xor eax,eax
	mov DenyCache[edx],eax
	mov DenyCache[edx+4],eax
	mov DenyCache[edx+8],eax
	mov DenyCache[edx+12],eax

	mov DenyCacheTime[ecx],eax
prenextcache:
;	pusha
;	print "- next",13,10
;	popa

nextcache:

	add edx,16 ; point to next DWORD
	cmp edx, sizeof DenyCache
	jb cleancache

skipclean:
TimerExit:

	ret

TimerProc endp


;------------------------------------------------------------------------------------------------


TimerProc2 proc lpParam:PVOID, TimerOrWaitFired:DWORD

; every 1 seconds, check if the logbuf3 contains data to write, and if so, write it and delete it.
; This must be done while we have exclusive rights to the writelog (LockLog)


; Each active IP has a WORD associated with it for it's history
	cmp timerflag2,0 ; always skip the first timer call
	mov timerflag2,1
	je  Timer2Exit
	; check if unwritten log data exists
	mov eax,logbytes
	test eax,eax
	jz Timer2Exit 
 	invoke LockLog ; have exclusive rights to the Log buffers
 	;open to the end of the existing file, and write the buffer to it, then close it.

	invoke WriteLogFlush
	xor eax,eax
	mov LogLock,eax  ; remove the process lock and exit
        
Timer2Exit:
	ret

TimerProc2 endp


; StartServer - Configure Console screen and tell Winsock to Accept TCP connections
  StartServer proc near

local rpos:dword            ; Position in CountryCode File


begin:
	cld ; Clear direction flag    
	mov MailSlotSound,0
	mov LaunchSpyNode,0
	;mov ShutdownFlag,0
	cmp RestartFlag,0
	jne skipinit

    	; StopEvent will be used as a shut down notification

	invoke CreateEvent,NULL,             ; security attributes
    		TRUE,             ; flag for manual-reset event
    		FALSE,            ; flag for initial state
    		addr StoppingTxt	; event text
            
	cmp eax, INVALID_HANDLE_VALUE
	je  init_console
	mov StopEvent,eax

init_console:

	invoke GetConsoleWindow                                ; Define Console Window Handle
	mov    hWnd,eax 
	invoke GetStdHandle,STD_OUTPUT_HANDLE                  ; Define Output Handle
	mov   hStdOut,eax
	Invoke SetConsoleTitle, ADDR Net2BBSTitle              ; Set Console Window Title
	;call   InitConsole

	invoke GetConsoleScreenBufferInfo,hStdOut,ADDR csbi

skipinit:
	invoke ResetEvent, StopEvent ; StopEvent must be Reset in case a Restart occurs
	cls 		 ; macro to clear the screen
	movzx ebx,csbi.dwSize.x ; Get screen column size, usually 80
	shl   ebx,1  ; Multiply column count by 2 to create a 2-line blue bar
	invoke FillConsoleOutputAttribute,hStdOut,31,ebx,NULL,ADDR temp    ; Create blue background color at top
	invoke SetTextColor, BRIGHT_GREEN+(DARK_BLUE*16) ; Bright Green text on blue background
	print " Net2BBSķ " ; Was -=Net2BBS=-
	invoke SetTextColor,WHITE+(DARK_BLUE*16) ; white text on blue background
	;print " Telnet Server 1.xx",225,"2" ; 1.xxB2
	invoke StdOut,ADDR TelnetSrvTxt
	invoke StdOut,ADDR VersionTxt

	xor ebx,ebx
	invoke locate,6,ebx
	print "2"               ; make the "2" in Net2BBS white
	invoke SetTextColor,BRIGHT_BLUE+(DARK_BLUE*16) ; blue text on blue background
	invoke locate,74,ebx
	print chr$(250),"pcm",250,13,10,10 ; sign it .pcm.
  
readini:
	call GetSettingsFromIni 	; Read the INI file and process it (this sets text color to green)
	jnc iniok
	jmp error_exit			; exit if INI file not found
iniok:	  


;	invoke memfill, ADDR NodeTable, sizeof NodeTable, ebx ; Zero fill Node table
;	invoke memfill, ADDR DenyCache, sizeof DenyCache, ebx ; Zero fill DenyCache table
;	invoke memfill, ADDR DenyCacheTime, sizeof DenyCacheTime, ebx ; Zero fill DenyCache table
;	invoke memfill, ADDR HistoryCache, sizeof HistoryCache, ebx ; Zero fill HistoryCache table
;	invoke memfill, ADDR HistoryCount, sizeof HistoryCount, ebx ; Zero fill HistoryCache table


    lea     edi,NodeTable
    xor     eax,eax
    mov     ecx,(sizeof NodeTable+sizeof DenyCache+sizeof DenyCacheTime+sizeof HistoryCache+sizeof HistoryCount) / 4
    ;cld
    rep     stosd



	mov ActiveNodes,al            ; no active nodes
	mov CachePtr,eax              ; Zero Cache Pointer    
	mov CacheLock,eax             ; Zero Cache Lock
	mov HistLock,eax              ; Zero History Lock
	mov LogLock,eax               ; Zero WriteLog2 Lock
	cmp byte ptr DebugModeTxt,"0"
	je Nodebug
	print "Debug: Cmd="
	invoke StdOut,ADDR CommandTxt
	invoke StdOut,ADDR CRLF		; print chr$(13),10

Nodebug:

	; The inet_ntop function is only available in Windows Vista+ so load it programmatically
	; returns NULL (not available) if the function is not found.
	invoke GetModuleHandle, addr ws2_32
	invoke GetProcAddress,eax, addr inetntop
       mov _inet_ntop,eax
;///////////
;xor eax,eax ; DEBUG
;///////////
       mov dual_stack,eax
;------------------------------------------------------------
; Point to the correct address structure
       test eax,eax
       jnz is_dual_stack

	cmp byte ptr DebugModeTxt,"0"
	je skip_stack_msg
       print "Debug: Dual-Stack not supported",13,10
skip_stack_msg:
not_dual_stack:
	mov ax,AF_INET
	mov AF_type,ax
	mov _addr4.sin_family,  ax 	    ; Set legacy address family
       lea eax, _addr4x
       lea ebx, _addr4xsize
       lea ecx, _addr4x.sin_addr
       jmp short set_stackmode
       
is_dual_stack:
	mov ax,AF_INET6
	mov AF_type,ax ;; Not needed?
	mov _addr6.sin6_family, ax 	    ; Set address family
       lea eax, _addr6x
       lea ebx, _addr6xsize
       lea ecx, _addr6x.sin6_addr
set_stackmode:
       mov _addrx, eax
       mov _addrxsize,ebx
       mov _addrx_sin_addr, ecx ; pointer to the proper sin_addr
;------------------------------------------------------------------


	invoke StdOut,ADDR CRLFLFLF ; move cursor 3 lines down
	invoke GetConsoleScreenBufferInfo,hStdOut,ADDR csbi
	movzx eax,csbi.dwCursorPosition.y ; Get 'y' Cursor position.
	dec eax
	dec eax
	mov HelpY,eax ; HelpY is the Vertical position of the help-text showing the hotkey commands.

	cmp RestartFlag,0
	jne skip_ws ; Don't re-enable Winsock if restarted

initws:
	invoke WSAStartup,0202h,addr wsadata	; Enable WinSock version 2
	.if eax!=NULL				; Check for error
		invoke SetTextColor,BRIGHT_RED	; set Color=Red
		print "WinSock Error"
	jmp error_exit
	.endif
       ;mov ax,AF_type
	;mov _addr4.sin_family, ax   	    ; Set address family
	;mov _addr4.sin_addr, INADDR_ANY	    ; use all network interfaces available


; Read countrycodes.txt

	invoke ReadMyFile, ADDR CountryCodeFile ; Open and read the File
	jc noccfile		; get out if the file was not found

	push esi			; save the file pointer so we can later Globalfree

	xor eax,eax	    ; start at the first line (position 0)
	mov rpos,eax
	lea ebx,BlockCC
       mov ebx,offset BlockCC
	jmp short linein0


readccloop:

	mov eax,rpos		; check if rpos=0, if so we are done
	test eax,eax
	jz ccfiledone

linein0:
	invoke ReadLine, esi,ADDR LogBuf,rpos ; Read a line from the textfile into LogBuf 
	mov rpos,eax        
	test ecx,ecx   ; blank line?
	jz readccloop  ; skip empty line
	cmp LogBuf,"-" ; check for minus
	jne readccloop ; skip any line that does not have a minus.

	mov WebGeoIPFlag,1   ; minus found, so add 2 letter CountryCode to table
;pusha
;print "found blocked country",13,10
;popa
	mov ax,word ptr LogBuf+1
	mov  [ebx],ax
	add ebx,2
	jmp readccloop

ccfiledone:

	mov [ebx], word ptr 0 ; zero terminate the CountryCode table
	pop eax
	invoke GlobalFree,eax 	; free the ccfile allocated memory
jmp skipccfile
noccfile:
print "NO CC file",13,10
skipccfile:
;----------------------------------------
; TIMER INIT:

	mov timerflag1,0 ; This will cause first timer call to be skipped
	mov timerflag2,0
    ;----------------------------------------
	; Create a timer with a 15 second period.
	;----------------------------------------

	invoke CreateTimerQueueTimer, ADDR phNewTimer, 0,
                                     TimerProc, ADDR TimerParam1,
                                     1, 15000, WT_EXECUTEINTIMERTHREAD
    ;.IF eax == 0
    ;    print "CreateTimerQueueTimer error"; %s\n",LastError$()
    ;    inkey
    ;.ENDIF
    ;
;2018!!!!!
;	invoke CreateTimerQueueTimer, ADDR phLogTimer, 0,
;                                     TimerProc2, ADDR TimerParam2,
;                                     1, 1000, WT_EXECUTEINTIMERTHREAD

;print "Timers set",10,13

;----------------------------------------
skiptimer:
skip_ws:


; for debug. jmp skipall

; Bind Telnet Server and accept connections in a new thread

	mov eax,TCPport ; Get Telnet Server TCP Port
	or  eax,eax
	jz skiptelnet ; Skip Telnet if zero

	invoke BindListen,eax   ; Bind TCP port and tell it to listen for connections
	jc telnetservererror
	mov hInSock,eax         ; Save telnet Socket handle

	; Create thread to accept telnet connections "Listening for telnet connections on port 23"
	xor eax,eax
	invoke CreateThread,eax,eax,offset AcceptThread,eax,eax,addr ThreadID
	invoke CloseHandle,eax		; Remove thread handle
	invoke WriteLog2, ADDR WaitingTxt, ADDR TelnetTxt, ADDR ConnectionsTxt, ADDR TCPportTxt, DARK_GRAY

skiptelnet:

; Bind Socket Policy Server and accept connections in a new thread
 
	mov eax,PolicyPort	; Get Policy Server TCP port
	or eax,eax
	jz skippolicy           ; Skip Policy if zero
	invoke BindListen,eax   ; TCP Port 843 = socket policy port
	jc policyservererror
	mov hInSock2,eax

	; Create thread to accept policy connections  ; "Listening for socket policy connections on port 555"
	xor eax,eax
	invoke CreateThread,eax,eax,offset AcceptThread2,eax,eax,addr ThreadID
	invoke CloseHandle,eax
	invoke WriteLog2, ADDR WaitingTxt, ADDR PolicyTxt, ADDR ConnectionsTxt, ADDR PolicyPortTxt, DARK_GRAY

skippolicy:
skipall:


; Now the Telnet Server and/or Policy Server threads are up and running, so just process keyboard commands.
 
; First Save cursor position

	invoke GetConsoleScreenBufferInfo,hStdOut,ADDR csbi
	mov ebx,HelpY
	invoke locate,0,ebx
	invoke SetTextColor,DARK_WHITE

	print "Commands: [ESC] Exit, [C] Configure INI, [E] Edit Blocked IP List, [F1] Help"

	invoke SetTextColor,WHITE + 0	; white text on black background
	invoke locate,11,ebx          ; Position cursor
	print "ESC"                   ; Whiten it
	invoke locate,23,ebx          ; Postion cursor
	print "C"                     ; Whiteen it
	invoke locate,42,ebx          ; Postion cursor
	print "E"                     ; Whiten it
	invoke locate,68,ebx          ; Postion cursor
	print "F1"                    ; Whiten it
	invoke StdOut,ADDR CRLFLFLF     ; print 10,10,13

	;cmp RestartFlag,0          ; Check if we restarted, if so we must clear restart message
	;je doreadkey
	;invoke Sleep,1000          ; wait one second
	;invoke locate,50,0
	;invoke SetTextColor,WHITE +(DARK_BLUE*16) ; White text on blue background
	;print "         "  ; remove the "Restarted" text from top bar
	;invoke locate,0,HelpY  ; Restore cursor to help line
	;dec RestartFlag        ; Clear flag

	mov RestartFlag,0

doreadkey:
	movzx eax,csbi.dwCursorPosition.y ; Get Saved 'y' Cursor position.
	invoke locate,0,eax
	invoke SetTextColor, BRIGHT_GREEN + 0 ; Green text on black background

readkey:
	getkey      	; get a key press
	or ecx,ecx		; is it an extended key code, (function key, arrow, etc)?
	jz standard_key	; skip this if its not.

extended_key:
	cmp al,59		; test for F1 key	
	je gotF1
	jne readkey		; ignore any other extended key

standard_key:
	cmp al,01Bh		; test for ESC
	je gotesc
	or al,020h		; force lower-case result
	cmp al,"e"		; test for "E" or "e"
	je gote
	cmp al,"c"		; test for "C" or "c"
	je gotc
	jne readkey		; loop if no matches

telnetservererror:
	invoke WriteLog2, ADDR ErrorTxt, ADDR TelnetSrvTxt, ADDR OnPortTxt, ADDR TCPportTxt, BRIGHT_RED

go_err_exit:
	jmp error_exit

policyservererror:
	invoke WriteLog2, ADDR ErrorTxt, ADDR PolicySrvTxt, ADDR OnPortTxt, ADDR PolicyPortTxt, BRIGHT_RED
	invoke SetTextColor,BRIGHT_GREEN + 0	; Set bright green text on black background

	;xor eax,eax
	;cmp eax,TCPport	; Check if telnet server is enabled
	;je go_err_exit	; if not, its a serious error
	jmp skippolicy	; otherwise treat as a soft error, no exit
;-----
gotF1:
	; "F1" was pressed - Run editor and pass file name of the HelpFile

	mov ebx, offset HelpFileName	; F1 pressed, Open Helpfile net2bbs.txt
	jmp RunEditor
;-----
gotc: 
	; "c" was pressed - Run editor and pass the name of the Configuration INI file 

	;print "Restart after saving changes",10,13
	mov ebx,offset IniFileName
	jmp RunEditor
;-----
gote:
	; "e" was pressed - Run editor and pass the name of the kill list

	mov ebx,offset KillFileName
	jmp short RunEditor
;------
gotesc:
	; "ESC" was pressed - Display a separate console buffer with a Red background to confirm exit

	invoke	SetTextColor,WHITE+(DARK_RED*16)   ; Create a new Console screen with White Text on Red Background
	xor	ecx,ecx
	invoke	CreateConsoleScreenBuffer,GENERIC_READ OR GENERIC_WRITE,ECX,ECX,CONSOLE_TEXTMODE_BUFFER,ECX
	mov	ebx,eax 	    ; Save Handle of Screenbuffer in ebx
	invoke	WriteConsole,ebx,ADDR HitEscAgainTxt, sizeof HitEscAgainTxt, ADDR written, NULL ;Print to it
	invoke	SetConsoleActiveScreenBuffer, ebx ; Activate it
	invoke	SetTextColor,BRIGHT_GREEN  ; Restore color of future output
	getkey			; wait for a second keypress
	push eax
	invoke CloseHandle,ebx	; close the red console buffer first (1.02 fix for Win 7)
	pop eax
	cmp al,01Bh		; ESC key?
	je cleanup		; If so, cleanup and exit
	or al,020h		; force lower-case result
	cmp al,"r"		; "R" or "r" to Restart?
	je restart
readkeyx:
    	jmp readkey    ; Return to main key menu


; ---------
; RunEditor runs the defined editor and passes it a filename to open.
; EBX = pointer to the filename string.

RunEditor:
	mov byte ptr EditorCmd, 0   ; Zero (terminate) the string
	invoke lstrcat, ADDR EditorCmd, ADDR EditorName    ; Copy the EditorName to the Editor Command line
	invoke lstrcat, ADDR EditorCmd, ebx  ; Add filename to edit to the "edit filename" Command Line

	mov sinfo_.cb,sizeof sinfo_ ; this is done to maintain compatibility with future versions of Windows
	invoke GetStartupInfo,addr sinfo_
	xor ecx,ecx
	invoke CreateProcess, ecx, ADDR EditorCmd, ecx, ecx, ecx,
			      ecx, ecx, ecx, addr sinfo_,addr pinfo_ 

	invoke CloseHandle, pinfo_.hThread			    ; Close open handles
	invoke CloseHandle, pinfo_.hProcess	   
	jmp short readkeyx     ; resume processing keyboard input

error_exit:
if service
	cmp ServiceFlag,0
	je error_exit2
	invoke SetEvent, StopEvent		; Tell the service to stop
	jmp short done
endif

error_exit2:
	invoke SetTextColor, WHITE
	print chr$(10), 13, "*** Press Enter to Exit ***"
jel:
	getkey
	cmp al,13  ; Got Enter?
	jne jel    ; jello till we do
	jmp short done

restart:
	inc RestartFlag

cleanup:
	invoke WriteLog2, ADDR StoppingTxt, ebx, ebx, ebx, BRIGHT_GREEN	; Fixes a bug in WriteLog

	invoke SetEvent, StopEvent		; Tell all nodes and threads to shut down
	cmp RestartFlag,0
	jne doit
	cmp ServiceFlag,0
	jne done ; avoid calling ShutDown twice
doit:
	call ShutDown			; Commence Shutdown	
done:
	cmp RestartFlag,1		; Don't exit if a restart command was performed
	je restart2

	invoke WSACleanup		; Cleanup Winsock

	mov eax,logbytes
	test eax,eax
	jz die
	invoke WriteLogFlush
die:
	invoke SetTextColor,WHITE + 0	; Set White text on black background
	ret				; Exit Net2BBS

restart2:
	;mov al,"B"
	;mov BBSTitle,al ; The first character of the BBS title gets zeroed, so restore it.
	jmp begin

StartServer endp

    
;-------------------------------------------------------------------------------------------------------
ShutDown proc near

	; invoke SetEvent, StopEvent	; In the future tell all threads to shut down

	mov eax,TCPport
	test eax,eax   ; is a TCP port defined?
	jz skiptelnet2
	invoke shutdown,hInSock,NULL ; SD_BOTH ; shutdown socket
	invoke closesocket,hInSock	; Close socket

skiptelnet2:
	mov eax,PolicyPort
	test eax,eax
	jz finished
	invoke shutdown,hInSock2,NULL; SD_BOTH ; shutdown socket
	invoke closesocket,hInSock2	; Close socket

finished:

; now we must wait for all open nodes to close by checking ActiveNodes

	mov ecx, 120 ; wait 1.2 second for all nodes to close
;
waitforshutdown:
	mov al,ActiveNodes	; wait for all active nodes to be closed
	or al,al
	jz alldown
	push ecx
	invoke Sleep,10
	pop ecx
	loop waitforshutdown

alldown:
	;invoke WSACleanup		; Cleanup Winsock
	;inc ShutdownFlag
	ret
ShutDown endp


;------------------------------------------------------------------------------------------------
BindListen proc near myPort:dword

; Bind a TCP port, and tell it to Listen for incoming connections. 
;
; "Socket" to get socket Descriptor.
; "htons" to convert TCP port from decimal to network bytes.
; "Bind" to own a TCP port.
; "Setsockopt" to set socket options.
; "Listen" for incoming connections on port.
;
; After this routine is done, "CreateProcess" can be used to pass each connection in its own thread.

	invoke memfill, ADDR _addr6, sizeof _addr6, 0; Zero fill
	invoke htons,myPort		    ; Convert port value to host/network bytes 
	mov _addr4.sin_port,  ax		    ; store sin_port to bind		
	mov _addr6.sin6_port, ax		    ; store sin_port to bind		
	movzx ecx,AF_type

	mov _addr6.sin6_family, cx
	;mov _addr4.sin_family,  cx 	    ; Set address family

	invoke socket, ecx,  SOCK_STREAM, IPPROTO_TCP
	mov ebx,eax  
	
	; Enable Dual-Stack by disabling IPv6 only.
	IPV6_V6ONLY equ 27    ; value missing from windows.inc
	invoke setsockopt, ebx, IPPROTO_IPV6, IPV6_V6ONLY, addr null, sizeof null
	;.if eax!=NULL
	   ;  print "setsockopt disable IP6_V6ONLY Failed",13,10
	;.endif


	.if (dual_stack!=0)
	   invoke bind,ebx,addr _addr6,sizeof _addr6   ; "Bind" to port socket
	.else ; Dual-Stack not supported
	   invoke bind,ebx,addr _addr4,sizeof _addr4   ; "Bind" to port socket
       .endif
        
	.if eax!=NULL						    ; Check for error
		print "Bind Failed",13,10
		stc
		ret
	.endif 

; SO_RCVTIMEO and SO_SNDTIMEO
;
; When using the recv function, if no data arrives during the period specified in SO_RCVTIMEO, the
; recv function completes. In Windows versions prior to Windows 2000, any data received subsequently
; fails with WSAETIMEDOUT. In Windows 2000 and later, if no data arrives within the period specified
; in SO_RCVTIMEO, the recv function returns WSAETIMEDOUT, and if data is received, recv returns
; SUCCESS.

; If a send or receive operation times out on a socket, the socket state is indeterminate, and should
; not be used; TCP sockets in this state have a potential for data loss, since the operation could
; be canceled at the same moment the operation was to be completed.


	invoke setsockopt, ebx, SOL_SOCKET, SO_RCVTIMEO, offset WSTimeOut, sizeof WSTimeOut ;recv timeout
	invoke setsockopt, ebx, SOL_SOCKET, SO_SNDTIME0, offset WSTimeOut, sizeof WSTimeOut ;send timeout

	invoke listen,ebx,3		; "Listen" for incoming connection (maximum=3) SOMAXCONN
	.if eax!=NULL				; Check for error
	   ;print "Listen Failed",10,13
	   stc
	   ret
	.endif

	clc
	mov eax,ebx ;Return socket handle in EAX
 	ret
BindListen endp

;------------------------------------------------------------------------------------------------

; 
;------------------------------------------------------------------------------------------------
; Telnet Server Section


;------------------------------------------------------------------------------------------------ 
; The AcceptCondition routine decides if we want to accept the connection based on the IP Address.
;
; The following rules apply:
; 1. If the IP address is in the whitelist, then always allow it to connect.
; 2. If the IP address is in the list of cached portscanners and Hammers, then reject it.
; 3. If the IP address has connected more then xx times in the past 60 seconds, then reject and cache it.

; We must maintain a list of the last xx connections during the past minute.
; If this history list exceeds 64 IP's, assume we are under attack - refuse all IP's that arn't whitelisted.
; The simplest way to maintain this would be to shift the current connections list every 15 seconds,
; and delete the older ones.
; Add the connecting IP to the History Cache, or if it already exists increase the count and make sure
; there have not been an excessive number of connections already for that IP.

; Once the connection is accepted there will be additional checks made by Net2BBS which could result
; in closing the connection and adding it to the deny cache, such as checking if the IP address is listed
; in the permanent Kill list, or is found in any of the DNS Blacklists or located in blacklisted countries.


AcceptCondition proc    lpCallerId :DWORD, 
                        lpCallerData :DWORD,
                        pQos :DWORD,
                        lpGQOS :DWORD,
                        lpCalleeId :DWORD,
                        lpCalleeData :DWORD,
                        g :DWORD,
                        dwCallbackData :DWORD

;local connectingIP:dword   ; the connecting IP Address, in binary format
local IPAddress[4]:dword   ; Psudo connecting IP Address, in binary format

local pIPAddress:dword     ; Pointer to either the internal or Psudo connection IP
local IP32_flag:dword      ; TRUE if IP Address is 32 bits
local INET128_flag         ; TRUE if IP Address is 128 bits and 2000::/3 INET
local IPtextbuf[64]:byte   ; Buffer to create text based IP address
local counter:dword        ; local counter
local count:byte           ; local count

;pusha
;print "Accept Condition",13,10
;popa

; lpCallerId contains the address of the connecting entity stored as a windows sockets sockaddr structure.
	pusha ; was ebx

	mov ebx, lpCallerId
	mov ebx,[ebx+4]

	mov eax,dual_stack
	test eax,eax
	jnz acceptcond_dualstack

; No Dual_Stack, so place 32-bit Address into 128-bit address

;pusha
;print "no dual-stack!",13,10
;popa
	mov IPAddress,eax   ; eax=0
	mov IPAddress+4,eax ; eax=0
	inc eax             ; eax=1
	mov IP32_flag,eax   ; turn on IP32 flag
	mov IPAddress+8,0FFFF0000h ; This signifies a 32-bit address is in +12,13,14,15
	mov eax, [ebx+4]     ; get 32-bit address
;pusha
;print "32-bit IP address="
;popa
;pusha
;print uhex$(eax),13,10
;popa


	mov IPAddress+12,eax ; set 32-bit address
	lea ebx,IPAddress
	jmp short HaveIP


acceptcond_dualstack:
	add ebx,8 ; [ebx] now points to IP Address of Connecting IP
; dual-stack enabled, so determine which type of address we have
	xor eax,eax
	mov IP32_flag,eax    ; assume a 128-bit IP address
	mov INET128_flag,eax ; assume non-internet address
	mov eax,[ebx]
	or  eax,[ebx+4]
	jnz addr128
	mov eax, [ebx+8]
	cmp eax,0FFFF0000h
	jne addr128
addr32:
	inc IP32_flag
	jmp short HaveIP
addr128:

; now check if it's a valid internet address (2000: to 3fff:
	mov eax,[ebx]
	and eax,0000FFFFh
	cmp eax,00002000h
	jb not_inet
	cmp eax,00003fffh
	ja not_inet
	inc INET128_flag
not_inet:

HaveIP: ; EBX now points to 128 bit IP

mov pIPAddress,ebx

;pusha
;mov eax,[ebx]
;print uhex$(eax),32
;mov eax,[ebx+4]
;print uhex$(eax),32
;mov eax,[ebx+8]
;print uhex$(eax),32
;mov eax,[ebx+12]
;print uhex$(eax),13,10
;popa

jmp skipwhite ; testing mode disables whitelist!!!
;------------


; First check the whitelist of binary IP addresses which are always allowed to connect.

	mov ecx, sizeof IPWhiteList-16
Search_whitelist:
	;cmp eax,IPWhiteList[ecx]  ; Search WhiteList for connecting IP
        mov eax,IPWhiteList[ecx]
        cmp eax,[ebx]
        jne nowhitematch
        mov eax,IPWhiteList[ecx+4]
        cmp eax,[ebx+4]
        jne nowhitematch
        mov eax,IPWhiteList[ecx+8]
        cmp eax,[ebx+8]
        jne nowhitematch
        mov eax,IPWhiteList[ecx+12]
        cmp eax,[ebx+12]
	je AcceptConnection2      ; If found, accept connection
nowhitematch:
	sub ecx,16                 ; otherwise check next one
	jns Search_whitelist

;pusha
;invoke dw2a,eax,ADDR temptext	;
;invoke StdOut,ADDR temptext
;print " = Network IP Address",10,13
;popa
    
	;call LockCache


skipwhite:
	mov edx, sizeof DenyCache-16

;--------------------
;pusha
;print "Searching DenyCache for IP:"
;mov eax,[ebx]
;print uhex$(eax),32
;mov eax,[ebx+4]
;print uhex$(eax),32
;mov eax,[ebx+8]
;print uhex$(eax),32
;mov eax,[ebx+12]
;print uhex$(eax),13,10
;popa
;--------------------


	mov eax,IP32_flag
	test eax,eax
	jnz SearchCache
	mov eax,INET128_flag
	test eax,eax
	jnz SearchCache2

SearchCache: ; Normal Search, IP specific

	push edi ; required

	lea esi,DenyCache
	add esi,edx
	mov edi,ebx
	mov  ecx,4
	;cld
	repe     cmpsd

        ;mov eax,DenyCache[ecx]
        ;cmp eax,[ebx]
        ;jne NotReject
        ;mov eax,DenyCache[ecx+4]
        ;cmp eax,[ebx+4]
        ;jne NotReject
        ;mov eax,DenyCache[ecx+8]
        ;cmp eax,[ebx+8]
        ;jne NotReject
        ;mov eax,DenyCache[ecx+12]
        ;cmp eax,[ebx+12]

	pop edi

	je RejectByCache       ; If found, reject connection
NotReject:
	sub edx,16              ; otherwise check next one
	jns SearchCache
	jmp short Cachegood

SearchCache2:
; Search DenyCache for 128-bit IP in a /64 block (ignoring last 2 dwords)
; only do this with valid Internet v6 IP's (2000:0000:: to 3fff:ffff::)
; If the IP address being searched for is a 32-bit IP, then this type of search should never be performed.
; Since the DenyCache can contains both 32-bit and 128-bit addresses, check if the first 2 dwords match. 
; If true, we need to make sure the 3rd dword is not ffff0000 as this would indicate that the denycache
; entry is for a 32-bit IP. 
;
; Rules:
; Never use this If 32-bit IP address is being searched for.
; If 128 bit IP address is being searched for, make sure that the DenyCache entry does not contain a
; 32-bit IP address (does not start with 0, 0,ffff0000)
; If the DenyCache IP address happens to start with 0,0, then also make sure it's not all zeros as this
; indicates an unassigned DenyCache entry.

	mov eax,DenyCache[ecx]
	cmp eax,[ebx]
	jne NotReject2       ; If not a match, accept connection
	mov edx,DenyCache[ecx+4]
	cmp edx,[ebx+4]
	jne NotReject2       ; If not a match, accept connection
	or eax,edx           ; check if first 2 dwords were zero, as this could indicate a 32-bit address
	jnz RejectByCache   ; If they are not both zero, we must reject
	mov eax, DenyCache[ecx+8] ; They are zero, so check 3rd dword for ffff0000 which indicates
	cmp eax,0ffff0000h        ; that our cache is a 32-bit address. if it is then dont reject
	je NotReject2         
	or eax,DenyCache[ecx+12]  ; since first 2 dwords were zero, make sure all 4 are not zero, 
	jnz RejectByCache         ; reject if the first 2 were matched zeros, but the second 2 are not zeros.
	                          ; even if the second 2 don't match they are still on the same /64 block.

; In the future an option could be added to only block exact match ip's.

NotReject2:
	sub ecx,16              ; otherwise check next one
	jns SearchCache2
;pusha
;print "Cache did not find a match",13,10
;popa

Cachegood:

; All the Denycache has now been searched, and the IP was not found
	;mov CacheLock,0

	mov eax,AntiHammer ; Check if AntiHammer mode enabled
	test eax,eax ;
	jz AcceptConnection ; If it's not, skip the check and accept the connection

; Connection was not found in the banned IP list (DenyCache), so now check how often this
; ip connection has connected in the last 15 seconds and in the last 60 seconds.
; in last 15 seconds connections=3 Then assume attack
; in the last minute connections=4 Then assume attack

; The following table is used:
; HistoryCache:
;    IP address, 16*64 bytes - 1024 bytes of memory
; HistoryCount:

;    Hit Counter, 4*64 bytes - 256 bytes of memory

; in the event of a bot attack, 

; Store the last 64 connections, that are not already in the DenyCache table
; each 4 bits is 15 seconds, so 0000 0000 0000 0000 each 15 second period can hold up to 15 connections, or 
;
; This way, every time that the 15 second counter gets called, it increments minutecounter only one of every 4 calls,
; and it shifts all the bits in each records HitCounter to the left by 4.

; 1. Check if connected IP address is in the IP_History table. If it is, then increment the counter
; 2. If the IP address is not in the IP History, then add it, and set the counter to 1.
; 3. If the IP address is in the IP history, then increment it, and see if it's hit counter is too high
;    in the current 15 seconds, or the past minute, then reject it and add it to the ban list.

	call LockHistory

	xor edx,edx
	dec edx ; edx=-1 means that no empty cells have been encountered yet
	mov ecx, sizeof HistoryCache-16

; We need the same variables as defined as we did in acceptcondition!


SearchHistory: ; Search History Cache for IP while finding empty cell

        mov eax,HistoryCache[ecx]
        mov esi,eax
        cmp eax,[ebx]
        jne NoHistoryMatch
        mov eax,HistoryCache[ecx+4]
        or esi,eax
        cmp eax,[ebx+4]
        jne NoHistoryMatch
        mov eax,HistoryCache[ecx+8]
        or esi,eax
        cmp eax,[ebx+8]
        jne NoHistoryMatch
        mov eax,HistoryCache[ecx+12]
        or esi,eax
        cmp eax,[ebx+12]
	je FoundHistory              ; If found, check the number of hits
NoHistoryMatch:
	test esi,esi                 ; test for emmpty cell
	jnz notempty
	mov edx,ecx                  ; save non-empty position in edx
notempty:
	sub ecx,16                   ; otherwise check next one
	jns SearchHistory


; Since the History was not found, create a new History entry for this IP.
; This is done by finding an IP address that is zero. If none are zero, then
; we have a problem. In this case we could simply ignore the list, and
; refuse all connections, assuming we are under attack.

	cmp edx,-1 ; check if there is no room for new history
	jne CacheHistory
	mov ebx, offset Blocked3Txt ; "Blocked (Under attack)"
	jmp RejectEBX

RejectByCache:

;pusha
;print "Rejected",13,10
;popa
	mov ebx, offset Blocked1Txt ; "Blocked (Cached IP)" 
	jmp RejectEBX


CacheHistory:

;pusha
;print "No History found, creating record.",13,10
;popa

	push edi

	mov esi,ebx  ; Copy 128-bit IP Address to [EBX] (Optimized)
	lea edi,HistoryCache
	xor ecx,ecx ; mov ecx,4
	add edi,edx
	mov cl,4
	;cld
	rep movsd


; 	mov eax,[ebx]
;	mov HistoryCache[edx],eax    ; Store the users IP address into HistoryCache
; 	mov eax,[ebx+4]
;	mov HistoryCache[edx+4],eax  ; Store the users IP address into HistoryCache
; 	mov eax,[ebx+8]
;	mov HistoryCache[edx+8],eax  ; Store the users IP address into HistoryCache
; 	mov eax,[ebx+12]
;	mov HistoryCache[edx+12],eax ; Store the users IP address into HistoryCache

	pop edi

	shr edx,2 ; div by 4
	mov HistoryCount[edx],1      ; And set this HistoryCount to 1

AcceptConnection:

	mov HistLock,0            ; release HistoryLock

AcceptConnection2:


	popa ; was pop ebx
	mov eax, CF_ACCEPT

	ret

FoundHistory:

;pusha
;print "IP History was found.",10,13
;popa

; The connected IP has a recent history of connections. Count them and either Ban+Reject
; the IP or update the history
; if there were 3 connections in the past 15 seconds, ban
; if there were 4 connections in the past 60 seconds, ban
; The IP address pointer is saved in EBX!


; currently ECX pointer is multiplied by 4, so bring back to normal
	shr ecx,2

	mov edx,HistoryCount[ecx]
	mov eax,edx
	and eax,0Fh ; eax now contains the old count

; Update the count by 1 but don't allow it to be more then 15 (4 bits), and merge that into ecx

	inc eax
	cmp al,16
	jne store4bits
	dec eax
	store4bits:
	and edx,0FFFFFFF0h
	or  edx, eax
	mov HistoryCount[ecx],edx ; Now count(4 bits) it updated
	cmp al,3
	jge Excessive1
	mov count,al
	mov counter,3

countloop:

	shr edx,4 ; shift bitmask to the right by 4-bits and place in eax
	mov eax,edx
	and eax,0fh ; shave off bits past 15
	add count,al
	dec counter
	jnz countloop
	cmp count,4
	jge Excessive2
	jmp AcceptConnection


Excessive1:
;pusha
;print "Excessive count was found in first few seconds",10,13
;popa
;jmp Ex2

Excessive2:
;pusha
;print "Excessive count found within past minute",13,10
;popa

Ex2:
; here we can add IP Address to to denycache, and then remove from our history!
; this allows us to block the IP longer then 60 seconds, but if a botattack is in progress
; then the denycache could get wiped out quicker.

	xor eax,eax
	mov HistoryCount[ecx],eax ; Remove the IP's history count

;    lea     edi,HistoryCache  
;	shl     ecx,2 ; mult by 4 for 128 bit addresses
;    add     edi,ecx
;    mov     ecx,4
;    ;cld
;    rep     stosd

	shl ecx,2 ; mult by 4 for 128 bit addresses
	xor eax,eax
	mov HistoryCache[ecx],eax    ; Remove the IP From our history
	mov HistoryCache[ecx+4],eax  ; Remove the IP From our history
	mov HistoryCache[ecx+8],eax  ; Remove the IP From our history
	mov HistoryCache[ecx+12],eax ; Remove the IP From our history
	
;pusha
;print "Adding IP to DenyCache",13,10
;popa

    mov ebx, pIPAddress
	invoke AddIPtoCache      ; Prevent IP from connecting again as long as the Cach exists.

;--------------------
;pusha
;print "After AddIPtoCache:"
;mov eax,[ebx]
;print uhex$(eax),32
;mov eax,[ebx+4]
;print uhex$(eax),32
;mov eax,[ebx+8]
;print uhex$(eax),32
;mov eax,[ebx+12]
;print uhex$(eax),13,10
;popa
;--------------------




	mov ebx, offset Blocked2Txt ; "Blocked (Hammering)


;---------
RejectEBX:         ; Reject the Connection:
                   ; EAX= Pointer to Binary IP Address of attempted connection
                   ; EBX= Pointer to ascii message rejection reason to write to the log.
mov eax, pIPAddress ; IS THIS NEEDED?!?

	;12/2017 mov eax, connectingIP

	;mov CacheLock,0 ; Clear the CacheLock

 	;pusha ; This is needed because My_ntop changes registers!

;pusha
;print "AcceptConnection Rejected",13,10
;popa

	;invoke My_ntop, _addrx_sin_addr, addr IPtextbuf      ;Create text IP Address
	invoke My_ntop, pIPAddress, addr IPtextbuf      ;Create text IP Address

	lea eax, IPtextbuf                 ; Save the pointer to the dotted text
	invoke LogBlocked, ebx, eax        ; Write the refusal message to the log

	mov HistLock,0                     ; release history lock
	popa
	mov eax, CF_REJECT
	ret

AcceptCondition endp

;------------------------------------------------------------------------------------------------
LockHistory proc near
pusha
LH1:
	mov eax,1          ; Attempt to take ownership of the LogLock flag.
	xchg eax,HistLock  ; Swap the contents of eax and the memory.
	or eax,eax         ; If it was zero before the swap, then we now own it.
	jz LH2
	invoke Sleep,10    ; otherwise wait and try again
	jmp short LH1
LH2:
popa
	ret
      
LockHistory endp

;------------------------------------------------------------------------------------------------
LockCache proc near
pusha
;print "entering LockCache",13,10
LC1:
	mov eax,1          ; Attempt to take ownership of the CacheLock flag.
	xchg eax,CacheLock ; Swap the contents of eax and the memory.
	or eax,eax         ; If it was zero before the swap, then we now own it.
	jz LC2
	invoke Sleep,10    ; otherwise wait and try again
	jmp short LC1
LC2:
;print "exiting LockCache",13,10
       popa
	ret

LockCache endp
;------------------------------------------------------------------------------------------------

AddIPtoCache proc near ; pHostIPAddr:DWORD

; Add the user's IP address to a circular cache which will not be accepted by the telnet server.
; Lock this function so no other threads can execute it at the same time, to prevent the chance
; of a corrupt pointer from occuring.
; 
; Enter with EBX=Pointer to HostIPAddr (binary 128 bits)


	call LockCache

;	mov ebx,[pHostIPAddr]        ; ebx= pointer to Binary IP Address


push edi
push esi

	mov esi,ebx  ; Copy 128-bit IP Address to [EBX] (Optimized)
	mov edx,CachePtr             ; edx= Pointer to next position in cache

	lea edi,DenyCache
	add edi,edx
	mov ecx,4
	;cld
	rep movsd

pop esi
pop edi


; this area broke!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	;mov edx,CachePtr             ; edx= Pointer to next position in cache
	;mov eax,[ebx]
	;mov DenyCache[edx],eax       ; Store the denied IP
	;mov eax,[ebx+4]
	;mov DenyCache[edx+4],eax     ; Store the denied IP
	;mov eax,[ebx+8]
	;mov DenyCache[edx+8],eax     ; Store the denied IP
	;mov eax,[ebx+12]
	;mov DenyCache[edx+12],eax    ; Store the denied IP

	mov eax,MinuteCounter
	add eax,CacheTime

	push edx
	shr edx,2 ; div by 4
	mov DenyCacheTime[edx],eax ; Store the expire time
	pop edx

	add edx,16                  ; increment the cache pointer
	cmp edx, sizeof DenyCache
	jb  CacheAdded
	xor edx,edx
CacheAdded:
	mov CachePtr,edx
	xor eax,eax
	mov CacheLock,eax  ; remove the lock
	ret

AddIPtoCache endp

;------------------------------------------------------------------------------------------------
AcceptThread proc near

; This thread accepts incoming telnet connections, and passes each one to its own SpawnNode Thread. 
;

local pIPAddrTxt:dword      ; pointer to the IP Address dotted text

AT_loop:

	; "Accept" a new incoming connection.

 	  invoke WSAAccept, hInSock, _addrx, _addrxsize, ADDR AcceptCondition, NULL

	.if eax!=INVALID_SOCKET					; If socket is good, Create the Thread. 
	    xor ebx,ebx
	    invoke CreateThread,ebx,ebx,offset SpawnNodeThread,eax,ebx,addr ThreadID ; eax is the winsock handle
	    invoke CloseHandle,eax
	.endif

	invoke WaitForSingleObject, StopEvent, 0 ; This may not be needed when using ExitProcess
	or eax,eax
	jnz AT_loop
	invoke ExitThread, eax

AcceptThread endp


;------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------
; Socket Policy Server

AcceptThread2 proc near

; This thread accepts incoming Socket Policy connections, and handles each one on its own.
; We could create a new thread for each connection, which would be required if this was a full
; feature policy server, but to keep it simple all we need to do is accept the connect, send the
; policy xml file, pause a little bit (10ms) and disconnect.

; The Policy Server uses the same buffer as the Log. file!
; so in order for this to be thread safe, we must put a mutex lock on it first

local IPtextbuf[64]:byte    ;
;local IPtextsize:dword


AT_loop2:
 	; "Accept" a new incoming connection.
	  invoke WSAAccept, hInSock2, _addrx, _addrxsize, ADDR AcceptCondition, NULL
    ;invoke accept,    hInSock2, ADDR _addr4x, ADDR _addr4xsize   	
								; _addr4x=buffer for incoming ip
	.if eax!=INVALID_SOCKET					; If socket is good, Create the Thread. 
	  mov hSock2,eax
	  invoke LockLog                           ; Lock the Write Log
	  invoke ReadMyFile, offset PolicyFileName ;attempt to read policy file		  
	  jnc AT2_do                               ; fail if it doesnt exist

	AT2_fail:
	  invoke lstrcpy,edi,ADDR MissingTxt  ; Copy "Missing: " text to buffer
	  add edi,sizeof MissingTxt-1         ; point EDI to end of buffer
	  mov esi,offset PolicyFileName       ; point ESI to start of the Policy filename
	  jmp short AT2_close

	AT2_do:
	  xor eax,eax
	  invoke send,hSock2,esi,ecx,eax		; Write the Policy file to the socket
	  invoke GlobalFree,esi			; free the Policy file allocated memory
	  invoke Sleep,50				; Pause a few ms
	  mov esi, offset SendPolicyTxt		; Point to "Sent policyname" text
	AT2_close:
	  invoke  closesocket,hSock2			; Close the Socket
	 ; invoke lstrcpy,edi,esi		; copy the policy filename to the Log buffer
; Policy IP text

;	invoke _inet_ntop,AF_INET6, _addrx_sin_addr, addr IPtextbuf, addr IPtextsize ; Create Ansi text IP Address
	invoke My_ntop, _addrx_sin_addr, addr IPtextbuf ; Create Ansi text IP Address




xor eax,eax
;invoke WriteLog3, 0, ADDR IPtextbuf, ADDR SendPolicyTxt, ADDR null, BRIGHT_GREEN
invoke WriteLog, ADDR IPtextbuf, eax	; Write it to log (and to screen)
	.endif

	xor eax,eax
	invoke        WaitForSingleObject, StopEvent, eax ; Check if a shutdown is requested
	or eax,eax
	jnz AT_loop2

	;invoke closesocket,hInSock2 ; This is now done at cleanup
	xor eax,eax
	invoke ExitThread, eax
AcceptThread2 endp


;------------------------------------------------
; SpawnNodeThread - This thread is created for each accepted telnet connection. It spawns NetFoss.

  SpawnNodeThread proc near hSock:dword

;----------------------------	
local hDupeSock:dword       ; The Duplicate Socket Handle
local Node:dword            ; Node number for this thread
local rpos:dword            ; Position in Blocked IP File
local pHostIPAddr:dword     ; pointer to the Host IP Address (non-dotted)
local pHostName:dword       ; pointer to the resolved HostName
local pIPAddrTxt:dword      ; pointer to the IP Address dotted text
local IPAddress[4]:dword    ; Alternate 128-bit binary IP Address
local is_whitelist:dword    ; flag set when IP has been whitelisted
local IP32:dword            ; Is the IP address in 32-bit format?
local sameipcount:dword     ; The number of duplicate IP's already connected
local NodeTxt[6]:byte       ; Node number in ascii
local zNodeTxt[6]:byte      ; zNode number in ascii
local HandleTxt[6]:byte     ; Handle number in ascii
local TempBuff1[128]:byte   ; Temp buffers to replace command line macros
local TempBuff2[128]:byte   ; 
local TempBuff3[128]:byte   ; 
local IPtextbuf[64]:byte    ;
local HostName[64]:byte;    ;
local Web_Buffer[1024]:byte ;
local cctext[3]:byte        ; Used by WebClient
;----------------------------

	mov ebx, _addrx_sin_addr
	mov eax,00303030         ; Fill node text with leading zeros
	mov dword ptr NodeTxt,eax

	mov eax,dual_stack
	test eax,eax
	jnz is_dual

; Not dual_stack, so pad the 4 DWORD IP
	mov IPAddress,eax   ; eax=0
	mov IPAddress+4,eax ; eax=0
	mov IPAddress+8,0FFFF0000h ; This signifies a 32-bit address is in +12,13,14,15
	mov eax, [ebx]     ; get 32-bit IP address from struct
	mov IPAddress+12,eax
	lea ebx, IPAddress
is_dual:
	mov pHostIPAddr, ebx     ; pointer to IP Address (binary)

	invoke My_ntop, ebx, addr IPtextbuf ; Create text IP Address
	mov IP32,eax

;invoke StdOut,addr IPtextbuf
;print chr$(13),10
;------------------------------------------------------------------------------------------------------------------

       lea ebx,IPtextbuf
       mov pIPAddrTxt,ebx
 
	invoke ioctlsocket,hSock,FIONBIO,offset BlockValue  ; Force blocking or non-blocking socket mode
	xor eax,eax
	mov is_whitelist,eax ; Zero whitelist flag
	mov Node,eax         ; v1.01 bugfix
	or eax,AntiScanner  ; Check AntiScanner
	jz skip_echo
	invoke send,hSock, offset ECHOCMD, sizeof ECHOCMD,0 ; Enable Echo
skip_echo:




; Before finding a free node, count how many nodes use the same IP.
checknodes:
	mov ebx, offset NodeTable
	mov edx, StartNode
	mov esi, pHostIPAddr ; beta 9 bug fix!
;pusha
;print "StartNode="
;popa
;pusha
;push esi
;print uhex$(edx),13,10
;print "location of source IP="
;pop esi
;print uhex$(esi),13,10
;
;popa

	dec edx
	shl edx,4 ; multiply by 16 (left 4) for 128-bit address
	add ebx,edx ; point ebx to startnode 
	mov edx,LastNode
	sub edx,StartNode ; now we have number of nodes to check in EDX

mov edi,StartNode ; for debug
mov tempnode,edi
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	inc edx ; add one to node count
	xor eax,eax ; zero same IP counter
mov sameipcount,eax
; now decide if we need to count connected same ip's

	mov eax,MaxSameIP ; if MaxSameIPs not defined, then skip the test
	test eax,eax
	jz logtelnet
;pusha 
;print "maxSameIp is defined",13,10
;popa

dontskip:

;----------------------------------------------
;pusha
;print "ABOUT TO COMPARE! source IP: "
;popa
;PUSHA
;print uhex$(esi)
;print "= location of source ip",13,10
;popa
;pusha
;mov eax,[esi]
;print uhex$(eax),32
;mov eax,[esi+4]
;print uhex$(eax),32
;mov eax,[esi+8]
;print uhex$(eax),32
;mov eax,[esi+12]
;print uhex$(eax),13,10
;popa
;-----------------------------------------------
;todo:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
; If the IP address is 128-bit INET then match by /64 (ignoring last 2 dwords)


node_loop:

;    push edi
	push esi
	mov     edi,ebx
	mov     ecx,4

	;mov  eax,INET128_flag ; if this is a 128-bit internet address, we should ignore lowest 2 dwords
	;test eax,eax
	;jz   nodecmp
	;shr  ecx,1 ; ecx=2

nodecmp:
	cld
	repe     cmpsd
    pop esi
;	pop edi
	jne notsameip

       ;mov eax,[esi]
       ;cmp eax,[ebx]
       ;jne notsameip
       ;mov eax,[esi+4]
       ;cmp eax,[ebx+4]
       ;jne notsameip
       ;mov eax,[esi+8]
       ;cmp eax,[ebx+8]
       ;jne notsameip
       ;mov eax,[esi+12]
       ;cmp eax,[ebx+12]
       ;jne notsameip

;----------------------
issame:
;pusha

;pusha
;print "match! source IP is the same! Node="
;popa
;pusha
;print uhex$(edi),13,10
;popa


;mov eax,[esi]
;print uhex$(eax),32
;mov eax,[esi+4]
;print uhex$(eax),32
;mov eax,[esi+8]
;print uhex$(eax),32
;mov eax,[esi+12]
;print uhex$(eax),13,10
;popa
;--------------------

	inc sameipcount        ; update "same IP" counter
	jmp nextip


notsameip:
;pusha
;print "not same ip",13,10
;mov eax,[ebx]
;print uhex$(eax),32
;mov eax,[ebx+4]
;print uhex$(eax),32
;mov eax,[ebx+8]
;print uhex$(eax),32
;mov eax,[ebx+12]
;print uhex$(eax),13,10
;invoke Sleep,150
;popa

nextip:
;pusha
;print "."
;;Invoke Sleep,50
;popa

	add EBX,16     ; bump pointer up
	inc tempnode ;edi ; temp!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	dec edx        ; one less node to check
	jnz node_loop  ; loop if more nodes

;pusha
;print "ALL NODES COMPARED",13,10
;print "Count of duplicate IPs: "
;popa
;pusha

;print uhex$(edx),13,10
;
;popa

       jmp short countdone ; count is complete



; Check if this IP is whitelisted. This is a secondary check done after the connection was
; accepted. The first whitelist check is done before accepting the connection in a separate thread.

;	mov ecx, sizeof IPWhiteList-4

;Search_whitelist2:
;	cmp eax,IPWhiteList[ecx]  ; Search WhiteList for connecting IP
;	je logtelnet_whitelist    ; If found, accept connection
;	sub ecx,4                 ; otherwise check next one
;	jns Search_whitelst2

;	xor edx,edx ; zero ip counter


;-------------------------------------------------------------------------------------------------------------------
countdone:

; we now have the number of same IP's in counter
; If the count is more then MaxSameIP then deny this ip.
mov eax,sameipcount
	cmp eax,MaxSameIP
	jb  logtelnet

	mov ebx,pHostIPAddr      ; ebx= pointer to Binary IP Address
	invoke AddIPtoCache ; Prevent IP from connecting again
;pusha
;print "IP Added to Cache",13,10
;popa

	xor ebx,ebx ; Special code for msg "Refused (Already Connected)"
	mov esi,offset RefusedTxt  ; for sendsock offset and size
	mov ecx,(sizeof RefusedTxt+sizeof Refused0Txt -1)
	lea edi, IPtextbuf ; kluge to send IP address text to sendclose
	jmp sendclose ; send message to client and close the connection


; Find a node number to use. At the same time count how many nodes currently use the same IP.

logtelnet_whitelist:
	inc is_whitelist ; Turn on whitelist flag

logtelnet:
	invoke LockLog				    ; Lock the WriteLog from other threads
	mov eax,is_whitelist			    ; Check if whitelisted
	test eax,eax
	jz notwhitelist
       
	invoke lstrcpy,edi,ADDR WhiteListedTxt	    ; Copy "WhiteList " text to buffer
	add edi,sizeof WhiteListedTxt-1		    ; point EDI to end

notwhitelist:  ; "Telnet Login: Node 1 opened."
	invoke lstrcpy,edi,ADDR TelnetTxt	    ; Copy "Telnet" text to buffer
	add edi,sizeof TelnetTxt-1		    ; point EDI to end
	invoke lstrcpy,edi,ADDR LoginTxt	    ; Copy "Login:" text to buffer
	add edi,sizeof LoginTxt-1		    ; point EDI to end

;	invoke WriteLog, ADDR LogBuf, pIPAddrTxt   ; Write it to log (and to screen)
; don't write it yet! (saves an extra line in the log file)
; at this point the log is still locked.
;;;;;;;;;;;;;;; EDI is reserved for LOG ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Now find the first free node number
findnode:
	mov ebx, offset NodeTable	; Point EBX to nodetable, indexed with ECX
	mov edx,StartNode
	dec  edx
	shl edx,4 ; multiply by 16
	add ebx,edx
	mov edx,StartNode ; now we have number of nodes to check in ECX  

findnode1:
;pusha
;print "Checking Node "
;popa
;pusha
;print uhex$(edx),13,10
;popa

	mov eax,[ebx]	        ; Is node in use?
	or eax,[ebx+4]
	or eax,[ebx+8]
	or eax,[ebx+12]
	jz foundnode ; All 4 dwords were zero, so node # found!

notfree:
       add ebx,16             ; point to next node table data
       inc edx                ; next node #
       cmp edx,LastNode
       jb  findnode1

; No nodes were found!
; get out with Node=0, and handle the "no node" refusal later on.

	xor edx,edx
	jmp  setnode
;!!!!!!!!!!!!!!!!

foundnode:
;PUSHA
;push esi
;print "found first free node number ",13,10
;print "location of source IP="
;pop esi
;print uhex$(esi),13,10
;
;
;sub ebx,offset NodeTable
;
;push ebx
;print "EBX="
;pop ebx
;print uhex$(ebx),13,10
;popa



;	mov ebx,[pHostIPAddr]        ; Get Internet Host Addr
;	MOV [ebx+ecx], EAX           ; Enable this node in the table

; copy the 4 Dwords from [ESI] to the node location [EBX]
push edi
	mov edi,ebx  ; Copy 128-bit IP Address to [EBX] (Optimized)
	mov ecx,4
;	cld ;!!!!!!!!!!
	rep movsd
pop edi

;       mov eax,[esi]
;       mov [ebx],eax
;       mov eax,[esi+4]
;       mov [ebx+4],eax
;       mov eax,[esi+8]
;       mov [ebx+8],eax
;       mov eax,[esi+12]
;       mov [ebx+12],eax

	inc ActiveNodes
;pusha
;print "node table updated with node",13,10
;invoke Sleep,50
;POPA

setnode:
	mov Node,edx			; Convert Node number to ascii
	test edx,edx
	jnz nodenot0
;pusha
;print "Node is Zero!",13,10
;invoke Sleep,50
;popa

nodenot0:
			; Get out if node=0
	invoke dw2a,edx,ADDR NodeTxt	; and store in NodeTxt

setznode:
	mov edx,Node
	sub edx,StartNode
	inc edx
	invoke dw2a,edx,ADDR zNodeTxt	; and store in zNodeTxt

;pusha
;print "Setznode completed",13,10
;invoke Sleep,50
;popa

; Write "Telnet login: Node x opened" to log

	invoke lstrcpy,edi,ADDR Node_	; Copy "Node " text to buffer
	add edi,sizeof Node_-1 ; point EDI to end
;-----------------------------------------------------------------------------
	invoke lstrcpy,edi,ADDR NodeTxt ; Copy Node Number text to buffer
	invoke lstrlen,ADDR NodeTxt	; point EDI to end
	add edi,eax
	invoke lstrcpy,edi,ADDR OpenedTxt	; Copy " opened." text to buffer
;-----------------------------------------------------------------------------
nonode2:
	inc MailSlotSound ; Tell MailSlot login sound
	invoke WriteLog, ADDR LogBuf, ADDR NodeTxt	; Write it to log (and to screen)
	;invoke WriteLog3, ADDR NodeTxt, ADDR LogBuf2, ADDR NodeTxt, ADDR OpenedTxt, BRIGHT_GREEN



	dec MailSlotSound ; Tell MailSlot no sound


; Write "IP: xxx.xxx.xxx.xxx" to log

;;invoke LockLog
;;invoke lstrcpy,edi,ADDR IPTxt ; Copy Node Number text to buffer

;;        add edi,(sizeof IPTxt)-1
;;	invoke lstrcpy,edi, pIPAddrTxt	    ; Copy IP Address Text
;;	add edi,sizeof pIPAddrTxt		    ; point EDI to end
;;	invoke WriteLog, ADDR LogBuf,  ADDR NodeTxt   ; Write it to log (and to screen)
invoke WriteLog3, ADDR NodeTxt, ADDR IPTxt, pIPAddrTxt, ADDR null, BRIGHT_GREEN

;-------------------- IP Address written to log -------------------------------------------------

	cmp byte ptr ResolveModeTxt,"0"	       ; Check if ResolveIP mode enabled
	je check_blockfile				 ; Get out if not
	xor eax,eax
	cmp Node,eax					 ; Get out if no node
	je ResolveIP

	mov eax,len(ADDR ResolveMsg)               ; Get size of the ResolveMsg
	invoke send,hSock,ADDR ResolveMsg,eax,0    ; Write the ResolveMsg text to the socket

;--------------------------------------
; Resolve the IP address to a hostname
;--------------------------------------
ResolveIP:

	;invoke gethostbyaddr,ADDR pHostIPAddr,4,AF_INET ; resolve HostIP Value into hostname


           ; getnameinfo - creates hostname and servicename from address
           ;
           ;   The flags parameter can be used to customize processing of the getnameinfo function.
           ;   The following flags are available:
           ;   NI_NOFQDN   - When set, local hosts only get their Relative Distinguished Name (RDN) returned.
           ;   NI_NUMERICHOST - returns the numeric form of the hostname instead of its name.
           ;
           ;        The numeric form is also returned if the hostname wont resolve by DNS.
           ;   NI_NAMEREQD  - When set, a host name that cannot be resolved by DNS results in an error.
           ;   NI_NUMERICSERV - When set, The service port number is returned instead of its name.
           ;            Also, if no hostname is found, the hostname is returned as the IP address.
           ;   NI_DGRAM   - Indicates the service is a datagram service. (providing different port numbers).

        .if (dual_stack==0)
        ;------ legacy mode ---------------
        xor eax,eax
        invoke getnameinfo, addr _addr4x, sizeof _addr4x,\
                            addr HostName,sizeof HostName,\
                            eax,eax,eax
        .else
        ;-------- dual stack mode ---------
        xor eax,eax
        invoke getnameinfo, addr _addr6x, sizeof _addr6x,\
        addr HostName,sizeof HostName,\
        eax,eax,eax
        .endif


	; mov ebx, offset UnknownTxt			; Assume IP won't resolve
	; test eax,eax
	; jz resolvefailed


	;mov ebx,[eax].hostent.h_name			; Resolve was successful!   
	lea ebx, HostName
	mov pHostName,ebx


resolvefailed:

	; Write "Hostname: domain.com" to log

	invoke WriteLog3, ADDR NodeTxt, ADDR ResolvedTxt, ebx, ADDR null, BRIGHT_GREEN

; Display the resolved hostname result to the user, along with a CR/LF

	cmp ShowHostTxt,"0"
	je check_blockfile

	xor eax,eax
	cmp Node,eax					 ; Don't show resolve if no node
	jz skipresult
	invoke send, hSock, ebx, len(ebx),0 ; Send resolved name to client

	invoke send,hSock, offset CRLF, sizeof CRLF-1,0 ; Send Carrage Return + Line Feed
	invoke atodw,addr ShowHostTxt  ; Number of milliseconds to show hostname for
	invoke Sleep,eax

skipresult:
    

;---------------
check_blockfile:
;
; Check if the telnet users IP or hostname exists within our file list of blocked IP's
;
; Variables used:
; rpos = Position in Blocked IP File
; ebx,ecx,edx,esi,edi will be overwritten by wildmatch


; Before checking the blockfile, allow a whitelisted IP to pass
	mov eax,is_whitelist
	test eax,eax
       jnz noblockfile
       ; BUG!!!!!!!!!!!!!! check if the allowed IP is the same as the current IP
       ;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! currently no checking is done?

	invoke ReadMyFile, ADDR KillFileName ; Open and read the KillFile
	jc noblockfile		; get out if the file was not found
	push esi			; save the file pointer so we can later Globalfree

	xor eax,eax	    ; start at the first line (position 0)
	mov rpos,eax
	jmp short linein
	
readloop:
	mov eax,rpos		; check if rpos=0, if so we are done
	test eax,eax
	jz blockdone

linein:
;	mov rpos, linein$(esi,ADDR TempBuff1,rpos) ; This macro reads a line, and updates position
	invoke ReadLine, esi,ADDR TempBuff1,rpos ; uses modified readline to check for buffer overflow.
	mov rpos,eax        

;	test eax,eax   ; end of source?
;	jz blockdone   ; don't exit yet still must test last line
	test ecx,ecx   ; blank line?
	jz readloop    ; skip empty line

; Before we run the WildMatch, we should remove any spaces from the end of line
; (another idea: could remove spaces from entire line)

kill_trailing:
	cmp byte ptr TempBuff1[ecx], " "    ; look for a space
	jne notspace
	dec ecx 			    ; loop till all checked
	jnz kill_trailing
	jmp  short readloop ; if the line is empty, skip the wildmatch on this line

notspace:
	mov byte ptr TempBuff1+1[ecx],0     ; define the end-of-line with a zero

; Future Idea: could check if first character is either a plus or minus
; + = always allow this ip (takes priority).
; - = deny this ip (assumed)
; if an IP was explecitly allowed using +, then always allow it even if there is a deny *.
; 
; so when a + is found that matches, end the search
; when a deny is found that matches, set the result as fail, and continue searching.
; at the end of search, check result


	invoke WildMatch, ADDR TempBuff1, pIPAddrTxt	; Compare Line with dotted IP text
	jnz gotwild
	cmp byte ptr ResolveModeTxt,"0"			; Check if resolving hostnames
	je readloop					; get out if not

	invoke WildMatch, ADDR TempBuff1,  pHostName	; Compare Line with HostName
	jz readloop					; Zero=No match, so go back to readloop


gotwild:

; Here we found a match, so send the killmsg (or killfile) and disconnect the user

	mov ebx,pHostIPAddr   ; eax= Pointer to Binary IP Address
;pusha
;print "Adding IP to Cache2",13,10
;popa
	invoke AddIPtoCache  ; add their IP address to the Cache
;pusha
;print "IP added to Cache",13,10;
;popa
	mov ebx,offset Refused3Txt
	invoke ReadMyFile, offset KillMsgFileName	; attempt to read killmsg file		  
	jc nokillmsgfile				; skip if it doesnt exist
sendfile:
	invoke send,hSock,esi,ecx,0			; Write the KillMsg file to the socket
	invoke GlobalFree,esi				; free the killmsg file allocated memory
	pop eax
	invoke GlobalFree,eax 	; free the killfile allocated memory
	jmp short killfinish

nokillmsgfile:
	mov esi,offset KillMsg
	mov ecx,sizeof KillMsg
sendclose:
	invoke send,hSock,esi,ecx,0	  ; Write the reason for disconnect to the socket
killfinish: ;
test ebx,ebx
jz Already_connected

	invoke LogRefused, ebx, ADDR NodeTxt ; , ebx ;, pIPAddrTxt ; Write the refusal message to the log/screen
        jmp short sleepclose

Already_connected:
	invoke WriteLog2, edi, ADDR RefusedTxt+10, ADDR Refused0Txt, ADDR null, BRIGHT_GREEN

sleepclose:
	invoke Sleep,100       ; wait a moment
socketclose:
	invoke closesocket,hSock			    ; Close the socket handle
	jmp freenode		; and close connection

blockdone:
	pop eax
	invoke GlobalFree,eax		; free the allocated memory of killfile

noblockfile:


; If there is a semaphore file, send it to winsock and refuse user.

	cmp byte ptr SemFileName,0	; Is Semaphore file defined?
	je  nosemfound			; skip if none
	invoke	ReadMyFile, offset SemFileName	; Read the entire semaphore file		 
	jc nosemfound						; Skip if it's not there
	push 0
	mov ebx, offset Refused2Txt
	jmp sendfile

nosemfound:
;       print "Semaphore was not found",10,13

; check if all nodes are busy (and handle the no nodes available state)

	xor eax,eax
	or  eax,Node
	jz noDNSblacklist	; If no Node is assigned, assume all nodes are busy

notbusy:
;print "not busy",13,10

	cmp DNSBL, 0 ; check if .ini file passed a blacklist URL
	je skipDNSBL1

	mov ebx, offset DotTxt
	call Check_DNSBL
	jc socketclose

skipDNSBL1:
	cmp DNSBL2, 0 ; check if .ini file passed a blacklist URL
	je skipDNSBL2

	mov ebx, offset DotTxt2
	call Check_DNSBL
	jc socketclose

skipDNSBL2:

	cmp DNSBL3, 0 ; check if .ini file passed a blacklist URL
	je skipDNSBL3

	mov ebx, offset DotTxt3
	call Check_DNSBL
	jc socketclose ; should we tell them they are blacklisted before closing?

skipDNSBL3:

	cmp DNSBL4, 0 ; check if .ini file passed a blacklist URL
	je skipDNSBL4

	mov ebx, offset DotTxt4
	call Check_DNSBL
	jc socketclose

skipDNSBL4:
noDNSblacklist:

check_webgeoip:
	cmp WebGeoIPFlag,0
	je  skip_geolog
;pusha
;print "calling WebClient",13,10
;popa
	invoke  WebClient, GeoIPWebPort, addr GeoIPWebTxt, addr Web_Buffer, addr IPtextbuf
;pusha
;print "WebClient completed",13,10
;popa

       ;GeoIPTxt        db  "GeoIP: ",0  ; US-United States (passed)

	test eax,eax ; check if we got a valid result
	jnz  got_validCC
	push eax
	lea ebx, UnknownTxt
	lea ecx,null
	jmp short geolog

got_validCC:

	mov dword ptr cctext,eax ; save zero terminated 2-character country code string
	push eax ;and save for later

; here we check if country code exists in denytable
; result will determine allow or deny!

	lea ebx,cctext
	invoke lstrcat, ebx, ADDR GeoDash   ; Append a dash after country code.
	invoke lstrlen,esi	; get len of esi here

	mov ecx,32 ; don't allow country name to be too more then 32 characters long.
	cmp eax,ecx
	jb sizeok
	mov [esi+ecx],byte ptr 0
sizeok:
	invoke lstrcat, ebx, esi ; Append the country name to log string

	lea ecx,BlockCC
	pop edx ; recover 2 letter CC

searchccblock:
	mov ax, [ecx]
	test ax,ax
	jz searchblockdone
	cmp ax,dx
	je foundcc
	add ecx,2
	jmp short searchccblock

foundcc:
	push eax        ; non-zero=found
	lea ecx, ListedTxt
	jmp short geolog

searchblockdone:
	xor eax,eax
	push eax        ; zero=not found
	lea ecx,PassedTxt

geolog:
	invoke WriteLog3, ADDR NodeTxt, ADDR GeoIPTxt, ebx, ecx, BRIGHT_GREEN  ;  (ebx=ADDR CountryCodeCode, ecx=ADDR CountryName)
	pop eax
	test eax,eax ; was country denied?
	jz check_antiscan ; zero=allow
	jmp socketclose   ; otherwise close connection

skip_geolog:
check_antiscan:

	mov eax,AntiScanner
	test eax,eax
	jz skip_read
;print "read data",13,10

try_recv:
	invoke recv, hSock, offset readbuf, sizeof readbuf, 0    ; Read data
	cmp eax,SOCKET_ERROR
;	je readfailed
jne got_read_data

	invoke WSAGetLastError          ; Check Last Error Code
	cmp eax, WSAEWOULDBLOCK         ; WSAEWOULDBLOCK = No Data
	je try_recv                     ; loop the wouldblock


got_read_data:
	cmp al,3
	jb below_expect                ; is it less then we expected?
	mov eax, dword ptr readbuf
	xchg al,ah
	cmp ax, 65535-4 ; check within range
	jb below_expect ; otherwise connection failed

skip_read:
	xor eax,eax
	cmp eax,Node
	jne do_spawn ; Only spawn if there is a node!

isbusy:         ; All nodes are in use, so send "BUSY" response and close.
	;print "isbusy",10,13

	mov ebx, offset Refused1Txt
	mov esi, offset BUSYtxt
	mov ecx, sizeof BUSYtxt
	jmp sendclose

readfailed:
;print "read failed",10,13
	invoke WSAGetLastError
	cmp eax, WSAETIMEDOUT   ; was it a timeout, or some other error?
	jne  freenode           ; free the node and exit if other, assume they disconnected.

;below_expect:

	mov eax,AntiScanner
	test eax,eax
	jz do_spawn

below_expect:
	mov ebx,pHostIPAddr      ; ebx= pointer to Binary IP Address
	invoke AddIPtoCache ;
;pusha
;print "ip added to cache3",13,10
;popa

	mov ebx, offset Refused4Txt
	mov esi, ebx
	mov ecx, sizeof Refused4Txt-2
	jmp sendclose

do_spawn:

; allow user to spawn a node.

; First send a signal to the Telnet Monitor informing it to launch a netspy monitor.

	mov eax,Node
	mov LaunchSpyNode,al
	xor ebx,ebx ; just send the 4 byte header
	call WriteMailSlot
	mov LaunchSpyNode,0

	; Duplicate the Socket Handle for the spawned process

	invoke	  GetCurrentProcess	; Get hProcess number
	mov ebx,eax

	invoke DuplicateHandle,ebx,hSock,ebx,addr hDupeSock,0,TRUE,DUPLICATE_SAME_ACCESS  ; Store the dupesockhandle value in ascii
	invoke dw2a,hDupeSock, ADDR HandleTxt      ; Create HandleTxt ascii

; Store the handle text in environment variable %SOCKET%


	invoke SetEnvironmentVariable,addr SockEnvVar,addr HandleTxt ; Set the SOCKET environment variable (6 chars max).
	invoke SetEnvironmentVariable,addr NodeEnvVar,addr NodeTxt   ; Set the NFNODE environment variable (6 chars max).


; Now NodeTxt and HandleTxt are defined, so replace *N/*H/*I/*R macros on the Command Line

 invoke Replace,ADDR CommandTxt,ADDR TempBuff1,ADDR ntext, ADDR NodeTxt   ; Replace *N with {node text}
 invoke Replace,ADDR TempBuff1, ADDR TempBuff2,ADDR htext, ADDR HandleTxt ; Replace *H with {handle text}
 invoke Replace,ADDR TempBuff2, ADDR TempBuff1,ADDR IPtext, pIPAddrTxt    ; Replace *I with {IP Address}
 invoke Replace,ADDR TempBuff1, ADDR TempBuff2,ADDR restext, pHostName    ; Replace *R with {Resolved text}
 invoke Replace,ADDR TempBuff2, ADDR TempBuff1,ADDR ztext, ADDR zNodeTxt  ; Replace *Z with {znode text}

; Now Command is in TempBuff1
; Do the same with the StartPath (place in TempBuff2)

 invoke Replace,ADDR StartPath, ADDR TempBuff2,ADDR ntext,ADDR NodeTxt	 ; Replace *N with {node}
 invoke Replace,ADDR TempBuff2, ADDR TempBuff3,ADDR ztext,ADDR zNodeTxt	 ; Replace *Z with {znode}


; Now spawn NetFoss to take over the connection

	invoke PlayWav,addr LogonWav			    ; Play the logon wav
	invoke lstrcpy,ADDR BBSTitleNode,ADDR NodeTxt ; Create Title (with node number)

	;cmp byte ptr ResolveModeTxt,"0"		    ; Check if ResolveIP mode enabled
	;je doshell						    ; Skip Clear if not
	;invoke send,hSock,ADDR ANSIClear,SIZEOF ANSIClear,0     ; Send an ANSI clear screen command

doshell:
	invoke Shell, ADDR TempBuff3, ADDR TempBuff1,hDupeSock  ; Shell to NF+BBS, passing Path + Command to Spawn

freenode:

	mov edi, offset NodeTable
	mov edx,Node
	dec edx
	js close   ; skip over node removal if node was zero
	shl edx,4 ; multiply by 16
	add edi,edx
	xor eax,eax

	mov     ecx,4   ; Mark node as available in Node Table (Optimized)
	;cld	
	rep     stosd   ; repeat-mov 4 dwords in place of below code

	;mov [edi],eax			; Mark node as available in Node Table
	;mov [edi+4],eax		; Mark node as available in Node Table
	;mov [edi+8],eax		; Mark node as available in Node Table
	;mov [edi+12],eax		; Mark node as available in Node Table
	mov Dec_ActiveNodes,1
	;dec ActiveNodes				; One less node
	mov MailSlotSound,2 ; Sound = Logoff
close:
	xor eax,eax
	cmp eax,Node                          ; Skip if node # not assigned
	je  nonode

      ; Write "Node x Closed" to Log
	invoke LockLog
	invoke lstrcpy,edi, ADDR Node_
	add edi,sizeof Node_ -1
	invoke lstrcpy,edi, ADDR NodeTxt
	invoke lstrlen,ADDR NodeTxt	; point EDI to end
	add edi,eax
	invoke lstrcpy,edi, ADDR ClosedTxt
	invoke WriteLog, ADDR LogBuf,  ADDR NodeTxt   ; Write it to log (and to screen)


; play wave only after log is written.
	invoke PlayWav,addr LogoffWav		; Play the logoff WAV
	mov MailSlotSound,0 		; finished with sound
	cmp Dec_ActiveNodes,1		; Check flag to decrement activenodes
	jne nonode
	dec Dec_ActiveNodes		; Clear the flag
	dec ActiveNodes			; One less active node

nonode:

	xor eax,eax
	invoke ExitThread, eax          ; End of Thread



;------------------------------------------------------
; Check a DNS BlackList with the IP client's IP Address


; DNSBL Queries  - DNS BlackLists
; 
; When a mail server receives a connection from a client, and wishes to check that client against a DNSBL
; (let's say, dnsbl.example.net), it does more or less the following:
; 1.Take the client's IP address say, 192.168.42.23 and reverse the order of octets, yielding 23.42.168.192.
; 2.Append the DNSBL's domain name: 23.42.168.192.dnsbl.example.net.
;   IP version 6 is also supported as described here:  https://www.spamhaus.org/organization/statement/12/
; 3.Look up this name in the DNS as a domain name ("A" record). This will return either an address, indicating
; that the client is listed; or an "NXDOMAIN" ("No such domain") code, indicating that the client is not.
; 4.Optionally, if the client is listed, look up the name as a text record ("TXT" record). Most DNSBLs publish
; information about why a client is listed as TXT records.
; 
; There is an informal protocol for the addresses returned by DNSBL queries which match. Most DNSBLs return an
; address in the 127.0.0.0/8 IP loopback network. The address 127.0.0.2 indicates a generic listing. Other
; addresses in this block may indicate something specific about the listing that it indicates an open relay,
; proxy, spammer-owned host, etc. For details see RFC 5782. Any result which is not in the 127.0.0.* range
; should not be considered a blacklist (because Spamhaus features a whitelist result as well).

; A newer type of DNSBL exists to determine what country an IP Address is located in. The most popular one is
; countries.nerds.dk located in Denmark, which provides the service at no cost.  This type of blacklist is not
; a list of spammers or infected/drone PC's, but rather just a method to allow entire countries to be denied
; access to a mail server or other TCP server.  For example, to check if an IP Address is from China, append the
; following domain name to the reversed-octet IP address: cn.countries.nerd.dk, and if this address resolves
; using a DNS server, it indicates that the IP address is located in China (.cn is the country code for China).
;
; Furthermore, there is a unique DNSBL: zz.countries.nerd.dk which instead of providing a pass or fail code for
; a particular country, it provides an ISO 3166 Country Code result, which identifies which country the IP
; address belongs to. Net2BBS was the first telnet server to support DNS-based GeoIP lookup.

Check_DNSBL:
;pusha
;print "Check_DNSBL",13,10
;popa

; enter with ebx=pointer to the leading dot text of the desired DNSBL host

; If the WebGeoIP method is being used, then dont use the zz.countries.nerd.dk
	cmp dword ptr [ebx], ".zz." ; see if our DNSBL starts with "zz"
	jne notzz
	cmp WebGeoIPFlag,1 ; Don't support zz mode if WebGeoIP is used
	jne nowebgeo
	clc
	retn

nowebgeo:
notzz:

	lea esi, TempBuff1     ; Point esi at the Fully build BlackList Hostname
	mov TempBuff1,0      ; Zero the length of BLHostName string 

.if IP32!=0  ; Dealing with 32-bit address

	mov ecx,pHostIPAddr

	.if dual_stack!=0
            add ecx,12
	.endif

	mov eax,[ecx]
;	mov eax,[pHostIPAddr]  ; Get 32-bit Internet Host Address
	bswap eax              ; Reverse the order of octets
	invoke inet_ntoa,eax   ; Convert to dotted IP addr, which eax will point to

.else ; Dealing with 128-bit address

	push ebx
	xor ecx,ecx
	mov ebx,dword ptr _addr6x.sin6_addr+12
	call reversedw
	mov ebx,dword ptr _addr6x.sin6_addr+8
	call reversedw
	mov ebx,dword ptr _addr6x.sin6_addr+4
	call reversedw
	mov ebx,dword ptr _addr6x.sin6_addr
	call reversedw
	pop ebx
	dec ecx ; remove trailing dot
	mov byte ptr TempBuff2[ecx],0
	lea eax,TempBuff2
.endif


; now eax points to the text buffer

	invoke lstrcat, esi, eax       ; Copy the dotted Reversed-IP string into BLHostName
	invoke lstrcat, esi, ebx       ; ebx=ADDR DotTxt - Append the dot followed by the DNSBL's domain name.
	inc ebx                        ; bypass the dot

;	print " The DNS BlackList reverse-IP Hostname is: "
;	invoke StdOut,ADDR TempBuff1
;	print " ",13,10
;---------------------------------------------------------
	invoke gethostbyname, esi     ;Attempt to resolve hostname for the IP address, put result in EAX

;---------------------------------------------------------------------
; If we are in zz.country mode, then EAX = The ISO 3166 Country Code
;---------------------------------------------------------------------

; otherwise, EAX = the DNSBL Result code (usually 127.*.*.*)

	or eax,eax
	jz DNSBL_passed_nocode		; If no record was found, the IP passed.
	mov eax,[eax+12]		; move the value of h_list member into eax 
	mov eax,[eax]			; copy the pointer to the actual IP address into eax 
	mov eax,[eax]			; copy hostname's resolved IP address into eax

; here we have the DNS result

result:
	cmp word ptr [ebx], "zz" ; see if our DNSBL starts with "zz"
	je  ProcessCountryCode

	and eax,00FFFFFFh  		    ; 127.0,0.1 = 0100007F hex
	cmp eax,0000007Fh                   ; (7F=127) Make sure result is in the 127.0.0.* range   
	jne DNSBL_passed                    ; otherwise it's assumed non-blacklisted and passed the test
	je  DNSBL_listed

ProcessCountryCode:

; if this is zz.countries.nerd.dk then we just want the lower nibble (and eax,FFFF0000h), then shift and invert it

	bswap eax          ; Reverse the order of octets to generate the 16 bit country code in AX, and ignore the other bits.
	and eax,00000fFFh  ; Only use the last 3 nibbles (max 4095), so CountryCodeTxt length is 4 chars max.
	push eax                             ; Save the Country Code
	invoke dw2a,eax,ADDR CountryCodeTxt	; Grab the Country Code in binary format
	invoke lstrcat, ADDR CountryCodeTxt, ADDR PostCCTxt ; Append a " - " to the end of the Country Code
	pop eax                               ; AX= ISO 3166 Country Code, so search for it im the BlockCC list.
	mov edx, offset BlockCC  ; EDX is the pointer to a binary list of blocked Country Codes

checkblockcc:

	cmp word ptr [edx],0     ; Are there no more array members to check?
	je DNSBL_passed          ; If so. it's not blocked.
	cmp ax,[edx]             ; Is currenty Array member the same as the current Country code?
	je DNSBL_listed          ; If so, block it.
	inc edx                  ; Point to next member
	inc edx
	jnz checkblockcc         ; Loop unconditionally
    ;---------------

DNSBL_listed:

;pusha
;	print " The DNSBL result is a bad IP",13,10
;popa

push ebx
	mov ebx,pHostIPAddr      ; eax= Binary IP Address
;pusha
;print "addIPtocache4",13,10
;popa
	invoke AddIPtoCache ; Add the IP Address to the denied cache list.
	mov ecx, offset ListedTxt ; or passed
pop ebx

;pusha
;print "added bad ip to cache4",13,10
;popa
	stc ; set carry to indicate bad IP
	jc  DNSBL_finish
;----

DNSBL_passed_nocode:
	mov dword ptr CountryCodeTxt,eax      ; Prevent CountryCode from being shown if no code was given
   
DNSBL_passed:
;pusha
;print " The DNSBL result is a Good IP",13,10
;popa
	mov ecx, offset PassedTxt ; or passed
	clc

DNSBL_finish:
	pushfd        ; Save Carry Flag

;if in zz mode, we must display the country code with a pass/fail result.

cmp word ptr [ebx], "zz" ; see if our DNSBL starts with "zz"
jne notCountry

	inc ecx
	inc ecx
	invoke lstrcat, ADDR CountryCodeTxt, ecx ; Append the pass/fail result to the end of the CountryCode text
	mov ecx,offset PreCCTxt

notCountry:
	; Write Country Code to log

	invoke WriteLog3, ADDR NodeTxt, ADDR DNSBLTxt, ebx, ecx, BRIGHT_GREEN  ;  (ebx=ADDR Dottxt, ecx=ADDR ListedTxt or Passed Txt)

	popfd         ; Restore the Carry Flag (set=blocked)
	retn          ; Return near

; Reverse the order of Dword in EBX, and convert to dotted octant string pointed to by TempBuff2[ecx] 
reversedw:
	bswap ebx
loop1:
	push ebx
	and ebx,0Fh
	mov al,hextable[ebx]
	mov ah,"."
	mov word ptr TempBuff2[ecx],ax
	pop ebx
	shr ebx,4
	inc ecx
	inc ecx
	test ecx,15
	jnz loop1
retn

SpawnNodeThread endp

;---------------------------------------------------------------------------------
; WebClient with XML lookup function

WebClient proc uses edi WebPort:dword,Web_Page, pWeb_Buffer:dword, IPtextbuf:dword

; Enter passing WebPort, Web_Page to display, Buffer for country name result
; Exit with:
;            EAX= 2 byte country code (i.e. US)
;            ESI= Pointer to Country Name ascii  

LOCAL   GetCommands[128]:byte   ; Buffer for Commands to send to Web Server
LOCAL   WebSocket:dword         ; Web Socket handle
LOCAL   Bytes_received:dword    ; Number of bytes received from Web Server
LOCAL   Socket_addr:sockaddr_in ; Simple socket structure

	lea edi, GetCommands
	invoke lstrcpy,edi, ADDR ReqCommand ; "GET "
	invoke lstrcat,edi, ADDR ReqFolder  ; "/xml/ "      
	invoke lstrcat,edi, IPtextbuf  ; Text Buffer for IP Address
 	invoke lstrcat,edi, ADDR ReqHTTP    ; " HTTP/1.1",13,10
	invoke lstrcat,edi, ADDR ReqUserHost; "Host: "
	invoke lstrcat,edi, ADDR GeoIPWebTxt    ; ReqHostName
	invoke lstrcat,edi, ADDR ReqClose   ; "Connection: close",13,10,13,10

; Send the Web commands to TCP port 80:
;DEBUG:
;invoke StdOut, Addr GetCommands
;getkey

winsock_open:
	invoke socket,AF_INET,SOCK_STREAM,IPPROTO_TCP
	cmp eax,INVALID_SOCKET
	jne socket_ok
	jmp WebClientClose ; fail
socket_ok:
	mov WebSocket,eax
	mov Socket_addr.sin_family,AF_INET
	invoke htons,WebPort
	mov  Socket_addr.sin_port,ax
	invoke gethostbyname,Web_Page
	test   eax,eax
	jnz    server_foundit
	jmp    WebClientClose ; fail
server_foundit:
	mov eax,[eax+12]
	mov eax,[eax]
	mov eax,[eax]  ; Get 32-bit IP address
inet_addr_ok:
	mov Socket_addr.sin_addr,eax
	invoke connect,WebSocket,addr Socket_addr,sizeof Socket_addr
	cmp eax,SOCKET_ERROR
	jne contact_host
	jmp WebClientClose ; fail

contact_host:
	;print "Connected to web server.",13,10,13,10
	invoke  lstrlen,edi ; Web_Commands
	invoke  send,WebSocket,edi,eax,0    
	mov     Bytes_received,0
Read_socket:
	mov eax,pWeb_Buffer
	add eax,Bytes_received
	invoke  recv,WebSocket,eax,1024,0
	cmp eax,SOCKET_ERROR
	je Answer_ready
Read_ok:
	test eax,eax
	jz Answer_ready
	add Bytes_received,eax  
    ;cmp Bytes_received,sizeof Web_Buffer-256
    ;jae Answer_ready
    ;jmp Read_socket
Answer_ready:
	mov eax,Bytes_received
	mov edx,pWeb_Buffer
	mov byte ptr[edx+eax-1],0

	; Debug: display Web Buffer
	; invoke  StdOut,pWeb_Buffer

	;print " ", 13,10,13,10
	;invoke crt_printf, chr$("We are done: %d bytes received..."),Bytes_received, 13,10

	lea edi, XML_CC
	call FindResult
	test esi,esi
	jz ResultFail
	xor eax,eax
	mov word ptr ax,[esi] ; get 2 character Country Code in AH and AL (AX)
	cmp al,"<" ; Empty XML=invalid internet IP
	je ResultFail

ResultFailnot:

	push eax ; Save Code for exit

; Get pointer to full Country Name

	lea edi, XML_CN
	call FindResult
	test esi,esi
	jz ResultFail2

;We now have the start of the Country Name, so search for the last valid character.
;End by could be <,/,zero, or any non-alpha numeric value. keep case in mind.
;Less then ASCII 65 = END OF STRING!

	xor ebx,ebx 
	mov edi,esi

findendloop:
	inc ebx

; allowed characters:
; Space   32
; Quote   34
; Paranth 40 41
; Period  46

	mov al, byte ptr[edi+ebx]
	cmp al, 32 ; Allow Space 
	je  findendloop
	cmp al, 34 ; Allow Quote
	je  findendloop
	cmp al, "A" ; Besides those, only allow "A" or higher-valued character as valid
	jae findendloop
	mov [esi+ebx], byte ptr 0 ; Otherwise Zero-terminate to end the string at current character

	;pusha
	;print "Here are results:"
	;popa
	;invoke StdOut, ESI
    
	pop eax ; restore CountryCode in EAX now!
	jmp WebClientClose    

ResultFail2:
	pop eax 

ResultFail:
;print "A match could not be found",13,10
	xor eax,eax

WebClientClose:
	push eax
	invoke  closesocket,WebSocket
	pop eax
	ret

;--------- local subroutine FindResult
FindResult:
; Enter with EDI= Pointer to string to search for
; Exit  with ESI= Pointer to one byte past found string in Web_Buffer
 
;	lea esi,Web_Buffer   
	mov esi,pWeb_Buffer   
	mov ecx, Bytes_received
	invoke lstrlen,edi ; get length of string to search for
	sub ecx,eax        ; CX counter=btyes_received-length of string
	mov edx,ecx ; backup ecx into edx (reverse counter)
	xor ebx,ebx
	inc ebx      ; EBX=1
retry:
	mov ecx,edx   ; reset ecx counter in case of retry
	mov eax,[edi] ; EAX=First 4 bytes to search for

find_cc:
	cmp eax,[esi]
	je  found_match
	add esi,ebx ; inc ESI
	sub ecx,ebx ; dec ECX
	jnz find_cc

;pusha
;print "The <marker> was not found",13,10
;popa
	xor esi,esi
	retn

found_match: ; Found first 4 matching characters, so compare the entire string
;pusha
;print "found_match",13,10
;popa
	mov edx,ecx ; save counter in case of failure
	invoke lstrlen,edi
	push edi
	mov  ecx, eax    
	repe cmpsb
	pop  edi
	jne  retry ; was not a full match, try again

; Success!
;pusha
;print "Sucess!",13,10
;popa
	retn ; Return with ESI=Location of result

WebClient endp

;------------------------------------------------------------------------------------------------
ReadMyFile proc near lpfilename

; This opens a file (if the file already exists), and reads the entire file into memory.
; Exit with Carry Set to indicate an error
; Exit with ESI= Global Memory handle (to be released) if successful
; AND ECX= bytes read

local hTempFile
local bytesread

	invoke GetFileAttributes, lpfilename		   ; Check if the file exists
	inc eax
	jz readmyfile_error

	invoke CreateFile,lpfilename,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,NULL
	mov hTempFile,eax
	invoke GetFileSize,eax,NULL	; get the file size
	push eax
	invoke GlobalAlloc,GMEM_FIXED,eax	;  allocate at least that much memory (Destroys ECX and ?)
	pop ecx
	mov esi, eax				;  Save the memory Handle.
	invoke	ReadFile,hTempFile,	;  Read the File
			esi,				;  Buffer Address
			ecx,				;  Max Amount to send
			ADDR bytesread, 		;  In: bytes actually read
			NULL				;  overlapped

	or eax,eax
	jz readmyfile_error ; This may be overkill since the file exists

; Here we could make sure the entire file was read, and try to read the remainder if needed.
; Exit this proce with carry set if there was an error?
		
	invoke CloseHandle, hTempFile		   ; close the file handle
	mov ecx, bytesread			   ; Return bytes read in ECX
	clc
	ret

readmyfile_error:
	;print "file not found",10,13
	stc
	ret

ReadMyFile endp

;------------------------------------------------------------------------------------------------
PlayWav proc near lpfilename
; 
; Check if a WAV file exits, and if it does, play it

	invoke GetFileAttributes, lpfilename
	inc eax		; Check that EAX!=-1
	jz NoPlay
	Invoke PlaySound, lpfilename, NULL, SND_FILENAME or SND_ASYNC
NoPlay:
	ret
PlayWav endp

;------------------------------------------------------------------------------------------------
WriteLog proc near lplogbuffer:DWORD, lpNodeTextAddr:DWORD
; define local equates here
local Node:dword            ; Node number for this thread
local rpos:dword            ; Position in Blocked IP File
local NodeText[4]:byte   ; 
local zeros[2]:byte

mov word ptr zeros,"00"

; 2017 Changes to writelog.
; Because the IP Address can be up to 39 characters long causing it to wrap to the next line on the
; 80 column console, the IP address will no longer be displayed in each line of the log.
; Instead the Node number will be displayed, in the format of 001.

; This writes the string passed to it to the log file (and screen), appending the current date and
; time to the beginning, and appends a CR/LF to the end. If a pointer to a Node number text string
; is provided, then the Node number is added after the time.
;
; All registers are saved

; for the mailslot, we need to send the additional 4 bytes:
; MailSlotColor (byte)
; MailSlotSound effect (byte)
; LaunchSpyNode (byte)
; ActiveNodes (byte)


	pusha      ; Save all registers

; First append CR/LF and zero to end of custom string:

	;invoke lstrcat, lplogbuffer, ADDR CRLF ; This won't work since the buffer is not zero terminated

	mov edi, lplogbuffer			; point EDI to end of log line buffer
	add edi,len (edi)
	mov dword ptr [edi],00000A0Dh		; append CR/LF/NULL to buffer, using mov dword for speed

; Get the Date and Time, and format it.

	invoke GetLocalTime,addr SysTime
	invoke GetTimeFormat,NULL,NULL,addr SysTime,SADD("HH':'mm':'ss "),addr TimeTxt,sizeof TimeTxt
	invoke GetDateFormat,NULL,NULL,addr SysTime,SADD("MM'-'dd'-'yyyy"),addr DateTxt,sizeof DateTxt
	mov byte ptr DateTxt+10," " ; put a space between date and time. 
	lea esi, LogBuf2		    ; Point ESI to buffer
	invoke lstrcpy,esi,Addr DateTxt	; Add Date+Time
	add esi,(sizeof DateTxt) + (sizeof TimeTxt)
	mov ebx,00202D20h		; " - ",0 
	mov [esi],ebx	    		        ; add it as a dword
	add esi,3                             ; skip the zero
; If the Node text is zero, then skip this part
	mov ecx,lpNodeTextAddr
	test ecx,ecx
	jz skipip

;Append 2 zeros if the Node number length is 1
;Append 1 zero if the Node number length is 2

;zeros db "00"
;nodetext,0

	mov eax, [ecx] ;dword ptr NodeText
	mov dword ptr NodeText,eax
	;invoke lstrcpy,addr NodeText,eax ; NodeTxt	  ; Copy the node test immediatly after the zero padding.

	invoke lstrlen,ecx           ; get the node string lengt (1,2, or 3)

	lea ecx, zeros-1
	add ecx,eax
	invoke lstrcpy,esi,ecx ; NodeTxt	  ; Append the 3 digit node text to buffer
	;add esi,3 ; eax
	;mov ebx, 00202D20h ; could use previous ebx value
	mov [esi+3],ebx				  ; add " - " as a dword
	add esi,6 ; was 3 (plus other add esi,3 above)
skipip:
	invoke lstrcpy,esi, lplogbuffer	  ; Copy main log text to 3 digit node text to logbuf2

	lea esi, LogBuf2
	;invoke lstrlen,esi			  ; Get size of new string
	;mov ebx,eax ; Store String Length in ebx


;--------------------------------------
	lea ebx,LogBuf3
	add ebx,logbytes
	invoke lstrcpy,ebx,esi   	  ; Append LogBuf2 node text to buffer
	invoke lstrlen,esi
        add logbytes,eax
        mov ebx,eax ; save size of LogBuf2 for writetomailslot
        cmp logbytes, (sizeof LogBuf3-100)
        jb writelogdone


; Write the entire line to the log

invoke WriteLogFlush

; Now also attempt to write it to the mailslot for Net2Mon

writelogdone:
	invoke StdOut,ADDR LogBuf2		  ; Print it to screen as well
	call WriteMailSlot
	xor eax,eax
	mov LogLock,eax  ; remove the process lock and exit
	popa
	ret

WriteLog endp

;------------------------------------------------------------------------------------------------
WriteLogFlush proc near    ; Flushes the Log buffer to the file

	invoke CreateFile,ADDR LogFileName,GENERIC_WRITE,FILE_SHARE_READ,0,
		OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	mov hLogFile,eax
	invoke SetFilePointer,hLogFile,0,0,FILE_END ; Point to end of log file
	invoke WriteFile,hLogFile,ADDR LogBuf3,logbytes,ADDR written,0 ; ebx=len
	invoke CloseHandle,hLogFile
	xor eax,eax
	mov logbytes,eax
	ret
WriteLogFlush endp


WriteMailSlot proc near
	add ebx,4 ; ebx contains length of string to write, so add 4 bytes for the header
	Invoke CreateFile,ADDR mailslot,   ; Filename 
		GENERIC_WRITE,        ; Write mode
		FILE_SHARE_READ,      ; Read mode
		0,                    ; ?
		OPEN_EXISTING,        ; Sharing
		FILE_ATTRIBUTE_NORMAL,; Attribute
		0                     ; ?	

	cmp eax, INVALID_HANDLE_VALUE ; Was the mailslot created ok?
	je nomailslot
	mov esi,eax                    ; esi = mailslot handle

	invoke WriteFile, esi,\   ; handle to write to
		ADDR MailSlotColor,\                       ; buffer address
		ebx,\                    ; max bytes to write
		ADDR written,\        ; bytes actually written
		0                           ; Flags

invoke CloseHandle, esi ; Close the mailslot

nomailslot:
	ret

WriteMailSlot endp


;------------------------------------------------------------------------------------------------
LockLog proc near

; Lock the WriteLog to prevent other threads from using it until it is released.
; This uses the xchg command which implies a LOCK condition to prevent any other
; thread from writing to the LogLock flag at the same time, allowing only one
; thread to take ownership while other threads must wait untill the lock is
; released by the completion of the WriteLog routine.

lockit2:
	mov eax,1          ; Attempt to take ownership of the LogLock flag.
	xchg eax,LogLock   ; Swap the contents of eax and the memory.
	or eax,eax         ; If it was zero before the swap, then we now own it.
	jz unlocked2
	invoke Sleep,10    ; otherwise wait and try again
	jmp short lockit2

unlocked2:
	lea edi,LogBuf	 ; Set EDI pointer to start of buffer
	ret

LockLog endp


;------------------------------------------------------------------------------------------------
WriteLog2 proc near String1:DWORD, String2:DWORD, String3:DWORD, String4:DWORD, Color:BYTE
; writelog2 never sends node number
; Mission: Call Writelog (without an NodeTxt address) passing 4 strings of text and a text color
; Writelog2 writes in correct order, 4 strings

	invoke LockLog
	lea edi,LogBuf
	invoke lstrcpy,edi, String1		; Copy "Waiting for telnet connections" text to buffer
	invoke lstrlen, String1	; point EDI to end
	add edi,eax
	invoke lstrcpy,edi, String2
	invoke lstrlen,String2	; point EDI to end
	add edi,eax
	invoke lstrcpy,edi, String3
	invoke lstrlen,String3	; point EDI to end
	add edi,eax
	invoke lstrcpy,edi, String4
	invoke SetTextColor,Color
	xor eax,eax
	invoke WriteLog, ADDR LogBuf, eax	; 0 means no NodeTxt passed. Write it to log (and to screen)
;print "wrotelog2",13,10
	ret
WriteLog2 endp

;------------------------------------------------------------------------------------------------
WriteLog3 proc near String1:DWORD, String2:DWORD, String3:DWORD, String4:DWORD, Color:BYTE
; writelog2 never sends node number
; Mission: Call Writelog (without an Nodetxt address) passing 4 strings of text and a text color
; WriteLog3 writes in correct order, 4 strings

	invoke LockLog
	lea edi,LogBuf
	invoke lstrcpy,edi, String2
	invoke lstrlen,String2	; point EDI to end
	add edi,eax
	invoke lstrcpy,edi, String3
	invoke lstrlen,String3	; point EDI to end
	add edi,eax
	invoke lstrcpy,edi, String4
	invoke SetTextColor,Color
	invoke WriteLog, ADDR LogBuf, String1	; Write String1. Write it to log (and to screen)
	ret
WriteLog3 endp

;------------------------------------------------------------------------------------------------ 
LogRefused proc near lpReasonText:DWORD, lpNodeTextAddr:DWORD 
; can the following 2 lines be removed?
	invoke WriteLog3, lpNodeTextAddr, ADDR RefusedTxt, lpReasonText, ADDR null, BRIGHT_GREEN
	ret

LogRefused endp

;----------------------------------------------------------------------------------------------- 

LogBlocked proc near lpReasonText:DWORD, lpIPTextAddr:DWORD 

	invoke WriteLog2, lpIPTextAddr, ADDR BlockedTxt, lpReasonText, ADDR null, BRIGHT_GREEN
	ret

LogBlocked endp


;----------------------------------------------------------------------------------------------- 
Shell proc near lppath:DWORD,lpfilename:DWORD,hShellSock:DWORD

; Shell - Spawn a process and wait for it to finish
; 
;
; LPCTSTR lpApplicationName,		       null
; LPTSTR lpCommandLine, 		       lpfilename
; LPSECURITY_ATTRIBUTES lpProcessAttributes,   null
; LPSECURITY_ATTRIBUTES lpThreadAttributes,    null 
; BOOL bInheritHandles, 		       true
; DWORD dwCreationFlags,		       create_new_cons+normal_prior (30h)
; LPVOID lpEnvironment, 		       null
; LPCTSTR lpCurrentDirectory,		       lppath
; LPSTARTUPINFO lpStartupInfo,		       addr sinfo
; LPPROCESS_INFORMATION lpProcessInformation   addr pinfo

local event_list[2]:DWORD               ; array of events to monitor
LOCAL sinfo:STARTUPINFO
LOCAL pinfo:PROCESS_INFORMATION

	cmp byte ptr DebugModeTxt,"0"
	je skipdebug
	invoke SetTextColor, DARK_GREEN
	print " Spawn: "
	invoke StdOut,lpfilename
	invoke StdOut,ADDR CRLF ; print $chr(13),10
	invoke SetTextColor,  BRIGHT_GREEN

skipdebug:

	mov sinfo.cb,sizeof sinfo ; this is done to maintain compatibility with future versions of Windows
	invoke GetStartupInfo,addr sinfo
	mov sinfo.lpTitle, offset BBSTitle
	; Set the Window Title

;	mov sinfo.dwFlags, STARTF_USESHOWWINDOW	; Demand setting window view mode.
	mov ebx, STARTF_USESHOWWINDOW			; Demand setting window view mode.

	invoke atodw,addr NodeLinesTxt		; Get NodeLines= value
	or eax,eax
	jz skipsize

	or ebx, STARTF_USECOUNTCHARS Or STARTF_USESIZE ;or STARTF_USEPOSITION

; This sets the console buffer size (buffer size can be bigger then screen size, but must not be smaller!)
	mov sinfo.dwXCountChars,80
	mov sinfo.dwYCountChars,eax
    
; The console screen size can only be set in Pixels, so we must assume the default font size of 8x12 for this to work:
; or we could use GetCurrentConsoleFont process (only for XP and above)


; CONSOLE_FONT_INFO structure doesn't seem to have a lot of practical use
; you can use the structure with GetCurrentConsoleFont (fills the structure)
; that fills in the nIndex value, that can then be used with GetConsoleFontSize to get dimensions
; but this only seems to apply to the current console font
; font height = 300/value in CONSOLE_FONT_INFO.dwFontSize.y
; font width = 640/value in CONSOLE_FONT_INFO.dwFontSize.x


	mov sinfo.dwXSize, 80*8 ; multiply X size by font width, and always use X-size=80
	mov edx,12              ; multiply Y size by font height 
	mul edx  
	mov sinfo.dwYSize, eax

skipsize:
	mov sinfo.dwFlags, ebx	; Set the STARTF flags.

  ; ShowWindow modes:
  ; These are described here:  http://msdn.microsoft.com/en-us/library/ms633548.aspx
  ;
  ; SW_HIDE = 0
  ; SW_NORMAL = 1
  ; SW_SHOWMINIMIZED = 2
  ; SW_MAXIMIZE = 3
  ; SW_SHOWNOACTIVATE = 4
  ; SW_SHOW = 5
  ; SW_MINIMIZE = 6
  ; SW_SHOWMINNOACTIVE = 7
  ; SW_SHOWNA = 8
  ; SW_RESTORE = 9
  ; SW_SHOWDEFAULT = 10
  ; SW_FORCEMINIMIZE = 11
 
	movzx ax,NodeView 	; Window Show mode: Normal, Minimize, Maximize, Hidden, etc.

; Full Screen View option was disabled in version 1.03a
; because this function was only supported in XP and 2003.
;
; cmp al,99 ;99=Full-Screen
; jne set_node_view
;=======================================================
; Force Full-Screen window by stuffing keyboard events
; Sends Alt-Enter to console for Win XP, 2000, and 2003
; This will not work under Windows Vista or later!
;  invoke keybd_event,VK_MENU,38h,0,0
;  invoke keybd_event,VK_RETURN,1Ch,0,0
;  invoke keybd_event,VK_RETURN,1Ch,KEYEVENTF_KEYUP,0
;  invoke keybd_event,VK_MENU,38h,KEYEVENTF_KEYUP,0
;  mov ax,SW_NORMAL
;=======================================================

set_node_view:
	mov sinfo.wShowWindow, ax

; CreateProcess
	xor ecx,ecx
	invoke CreateProcess, ecx, lpfilename, ecx, ecx, TRUE,
			CREATE_NEW_CONSOLE Or NORMAL_PRIORITY_CLASS,
			ecx, lppath, addr sinfo, addr pinfo


  .if eax 

; Wait for either the process to terminate or the StopEvent to be triggered

	;invoke closesocket,hShellSock  		; Close the socket


	mov eax, pinfo.hProcess 
	mov event_list+4,eax 
	mov eax,StopEvent
	mov event_list,eax

	invoke WaitForMultipleObjects,\
		2,\                             ; number of events
		ADDR event_list,\               ; events
		FALSE,\                         ; return if any event is signaled
		INFINITE                        ; Wait forever

  .else
	cmp byte ptr DebugModeTxt,"0"
	je Shell_end
	invoke SetTextColor,DARK_GREEN + 0	    ; Text = Dark Green
	print " Spawn Failed!",13,10
	invoke SetTextColor,BRIGHT_GREEN + 0	    ; Text = Bright Green
  .endif 

Shell_end:
	invoke shutdown,hShellSock,SD_BOTH		; force disconnect
	invoke closesocket,hShellSock  		; Close the socket 	
	invoke CloseHandle, pinfo.hThread		; Close open handles
	invoke CloseHandle, pinfo.hProcess	   
	ret

Shell endp


;------------------------------------------------------------------------------------------------
; Get Settings from net2bbs.ini

GetSettingsFromIni proc near ; uses ebx esi edi

    ;LOCAL   APP_Path[128] :BYTE
    LOCAL   INI_Path[128] :BYTE

    CTEXT MACRO text:VARARG
      LOCAL TxtName
      .data
	TxtName BYTE text, 0
      .code
      EXITM <ADDR TxtName>
    ENDM
    
	;invoke  GetAppPath, ADDR APP_Path			; Get path of Application  
	invoke  GetAppPath, ADDR INI_Path			; Get path of Application for INI
 	invoke  SetCurrentDirectory, ADDR INI_Path      ; Set CurrentDirectory (in case of Service)

	invoke lstrcat, ADDR INI_Path, ADDR IniFileName	; Append the Ini FileName to the INI path 	   

	; Make sure ini file can be found, or else we fail.

	invoke GetFileAttributes, addr INI_Path ; Does the .ini file exist?
	inc eax				; -1 means it doesn't exist
	jnz iniread
	invoke SetTextColor,BRIGHT_RED + 0
	;print  "Config missing: "
	invoke StdOut,ADDR MissingTxt
	invoke SetTextColor,7 + 0	; color=White
	invoke StdOut,ADDR INI_Path
inifail:
	stc 				; set carry to indicate error and exit
	ret
		
iniread:
	lea eax,INI_Path
	mov INI_ADDR, eax


; GetFromIni uses:  Command Text, default value, Where to place it, maximum size in bytes

 invoke GetFromIni, CTEXT("Command"),    ADDR null,    ADDR CommandTxt, sizeof CommandTxt
 invoke GetFromIni, CTEXT("StartPath"),  ADDR DotSlash,  ADDR StartPath, sizeof StartPath
 invoke GetFromIni, CTEXT("Port"),       CTEXT("23"),ADDR TCPportTxt,sizeof TCPportTxt
 invoke GetFromIni, CTEXT("PolicyPort"), ADDR zero,  ADDR PolicyPortTxt,sizeof PolicyPortTxt
 invoke GetFromIni, CTEXT("Nodes"),      CTEXT("256"),ADDR MaxNodesTxt, sizeof MaxNodesTxt
 invoke GetFromIni, CTEXT("StartNode"),  ADDR one,   ADDR StartNodeTxt, sizeof StartNodeTxt
 invoke GetFromIni, CTEXT("Debug"),      ADDR one,   ADDR DebugModeTxt, sizeof DebugModeTxt
 invoke GetFromIni, CTEXT("Resolve"),    ADDR one,   ADDR ResolveModeTxt, sizeof ResolveModeTxt
 invoke GetFromIni, CTEXT("DNSBL"),      ADDR null,  ADDR DNSBL, sizeof DNSBL
 invoke GetFromIni, CTEXT("DNSBL2"),     ADDR null,  ADDR DNSBL2, sizeof DNSBL2
 invoke GetFromIni, CTEXT("DNSBL3"),     ADDR null,  ADDR DNSBL3, sizeof DNSBL3
 invoke GetFromIni, CTEXT("DNSBL4"),     ADDR null,  ADDR DNSBL4, sizeof DNSBL4
 invoke GetFromIni, CTEXT("BlockCC"),    ADDR null,  ADDR BlockCCTxt, sizeof BlockCCTxt
 invoke GetFromIni, CTEXT("MaxSameIP"),  ADDR null,  ADDR MaxSameIPTxt, sizeof MaxSameIPTxt
 invoke GetFromIni, CTEXT("Log"),        CTEXT("telnet.log"),     ADDR LogFileName, sizeof LogFileName
 invoke GetFromIni, CTEXT("Editor"),     CTEXT("notepad"),        ADDR EditorName, sizeof EditorName
 invoke GetFromIni, CTEXT("KillList"),   CTEXT("kill.txt"),       ADDR KillFileName, sizeof KillFileName
 invoke GetFromIni, CTEXT("KillMsg"),    CTEXT("Access Denied."), ADDR KillMsg, sizeof KillMsg
 invoke GetFromIni, CTEXT("WhiteList"),  CTEXT("127.0.0.1"),      ADDR WhiteListTxt, sizeof WhiteListTxt
 invoke GetFromIni, CTEXT("KillMsgFile"),ADDR null,  ADDR KillMsgFileName, sizeof KillMsgFileName
 invoke GetFromIni, CTEXT("Semaphore"),  ADDR null,  ADDR SemFileName, sizeof SemFileName
 invoke GetFromIni, CTEXT("ResolveMsg"), ADDR null,  ADDR ResolveMsg, sizeof ResolveMsg
 invoke GetFromIni, CTEXT("ShowHost"),   ADDR zero,  ADDR ShowHostTxt, sizeof ShowHostTxt
 invoke GetFromIni, CTEXT("NodeView"),   ADDR one,   ADDR NodeViewTxt, sizeof NodeViewTxt
 invoke GetFromIni, CTEXT("MainView"),   ADDR one,   ADDR MainViewTxt, sizeof MainViewTxt
 invoke GetFromIni, CTEXT("NodeLines"),  ADDR zero,  ADDR NodeLinesTxt, sizeof NodeLinesTxt
 invoke GetFromIni, CTEXT("Blocking"),   ADDR zero,  ADDR BlockingTxt,  sizeof BlockingTxt
 invoke GetFromIni, CTEXT("CacheTime"),  CTEXT("120"), ADDR CacheTimeTxt, sizeof CacheTimeTxt
 invoke GetFromIni, CTEXT("AntiHammer"), CTEXT("1"), ADDR AntiHammerTxt, sizeof AntiHammerTxt
 invoke GetFromIni, CTEXT("AntiScanner"), CTEXT("1"), ADDR AntiScannerTxt, sizeof AntiScannerTxt
 invoke GetFromIni, CTEXT("GeoIPWeb"),   CTEXT("freegeoip.net"), ADDR GeoIPWebTxt, sizeof GeoIPWebTxt
 invoke GetFromIni, CTEXT("GeoIPPort"),  CTEXT("80"), ADDR GeoIPPortTxt, sizeof GeoIPPortTxt


	invoke atodw,addr GeoIPPortTxt	; Save the NodeView= value
    test eax,eax
    jz skipGeoIPPort
	mov GeoIPWebPort,eax
skipGeoIPPort:



	xor ebx,ebx
	cmp byte ptr BlockingTxt,"1"
	je  not_one
	inc ebx
	not_one:
 	mov BlockValue,ebx ; zero BlockValue for Blocking Sockets, one for non-blocking

	mov al,'.'
	mov DotTxt,al       ; Place a dot in front of each DNSBL hostname String to avoid an extra lsrcat
	mov DotTxt2,al
	mov DotTxt3,al
	mov DotTxt4,al

; Proccess the Blocked Country Code list (BlockCC) converting the country ascii code numbers into binary

; esi=character being processed
; edi=binary number table pointer
; ebi=first character of current ascii number

	mov lastchar,1 ; non-zero indicates end-of-line not reached
	mov esi, offset BlockCCTxt
	mov edi, offset BlockCC
	mov ebx, esi  ; ebx=start of number

findnumberend: ; find the end of the ascii number
	mov al,[esi]
	cmp al,'0'
	jb endofnumber
	cmp al,'9'
	ja endofnumber
	inc esi
	jnz findnumberend

endofnumber:             ; a non-numeric digit was found

	mov lastchar,al      ; save the non-digit to check later if its a zero
	mov byte ptr [esi],0 ; terminate the number with a zero

; ecx points to the end of the number
; go ahead and process it

	invoke atodw,ebx	 ; convert ascii text to dword
	mov [edi],ax       ; save 16-bit binary number in our array
	add edi,2          ; adjust array pointer

;--- debug code ---------------
;push ax
;xor eax,eax
;pop ax
;pusha
;invoke dw2a,eax,ADDR temptext	;
;invoke StdOut,ADDR temptext
;print " = The value read",10,13
;popa
;------------------------------

;check if we are done
	cmp lastchar,0      ; If the last character was 0, its the end of the line
	je ccdone
	inc esi             ; otherwise restart at next character
	mov ebx,esi         ; remember it is the first character of the next ascii number
	jmp findnumberend   ; loop


ccdone:
	xor eax,eax     ; zero-terminate our binary array
	mov [edi],ax

;---------------------
; process IP WhiteList

; Scan the WhiteListTxt to find either a "," or an end of line character

; esi=character being processed
; edi=binary number table pointer
; ebi=first character of current ascii number

	mov ecx,4       ; maximum addresses to process
	mov esi, offset WhiteListTxt-1
	mov edi, offset IPWhiteList

next_address:
	mov ebx, esi  ; ebx=start of IP Text
       inc ebx
findaddr_loop:       
       inc esi
findaddress_end: ; find the end of the ascii number
	mov al,[esi]
       cmp al," "
       je next_address
	cmp al,"."
	je findaddr_loop
	cmp al,'0'
	jb endofaddress
	cmp al,'9'
	jna findaddr_loop

endofaddress:             ; a non-numeric digit was found, so this address is done

	mov byte ptr [esi],0 ; terminate the numeric text with a zero

; esi points to the end of the number
; go ahead and process it

push ecx
	invoke inet_addr, ebx		; Convert dotted IP Address text to binary (NETWORK BYTE ORDER)
pop ecx
       cmp eax,INADDR_NONE ; check if IP is valid
       je invalid_ip
	mov [edi],eax      ; save binary number in our WhiteList table
	add edi,4          ; adjust array pointer to point at next dword

;pusha
;invoke dw2a,eax,ADDR temptext	;
;invoke StdOut,ADDR temptext
;print " = Network IP Address",10,13
;invoke Sleep,1000
;popa

;jmp skipit
invalid_ip:
;print "invalid ip",13,10
;pusha
;invoke Sleep,1000
;popa
skipit:
dec ecx
jnz next_address



;invoke lstrcat, ADDR KillMsg, ADDR CRLF ; Add CR/LF to end of killmsg?

	cmp byte ptr StartPath,0 ; Empty StartPath is illegal
	jne pathok
	invoke lstrcat, ADDR StartPath, ADDR DotSlash   ; Add a ./ to an empty StartPath 
pathok:

	invoke lstrcat, ADDR EditorName, ADDR spacestring   ; Add a space to the base EditorName 
	invoke lstrcat, ADDR ResolveMsg, ADDR spacestring   ; Add a space to the resolve message 
	;invoke lstrcat, ADDR EditorName, ADDR APP_Path      ; Add the Application path to the EditorName
	; There is no longer any need to add the app path to the editor name since we changed to the app dir

	invoke atodw,addr NodeViewTxt	; Save the NodeView= value

SetNodeView:

	mov NodeView,al
	invoke atodw,addr MainViewTxt	; Get MainView= value

	invoke ShowWindow,hWnd,eax   ; Set our Console Window view

skipShowWin:

; this is now done later
;	invoke atodw,addr NodeLinesTxt	; Get NodeLines= value
;	mov NodeLines,eax
	
	invoke atodw,addr TCPportTxt	; Save the provided TCP port if its non-zero
	mov TCPport,eax

	invoke atodw,addr PolicyPortTxt	; Save the provided Policy port
	mov PolicyPort,eax

	invoke atodw,addr StartNodeTxt	 ; Save the start node if its non-zero
	or eax,eax
	jnz setstartnode
	inc eax
setstartnode:
	mov StartNode,eax

	invoke atodw,addr MaxNodesTxt	; Save the max nodes if its non-zero
	;or eax,eax
	;jnz setmaxnode
	;mov ax,256
setmaxnode:
	mov MaxNodes,eax
	add eax,StartNode
	dec eax
	;shl eax,2 ; multiply by 4
	mov LastNode,eax		; Define LastNode (StartNode+MaxNodes-1)

setmaxsameip:
	invoke atodw,addr MaxSameIPTxt ; Save the max same IP's allowed to be connected
	mov MaxSameIP, eax

	invoke atodw,addr CacheTimeTxt	; Get CacheTime= value
	mov CacheTime,eax

	invoke atodw,addr AntiHammerTxt	; Get AntiHammer= value
	mov AntiHammer,eax

	invoke atodw,addr AntiScannerTxt	; Get AntiScanner= value
	mov AntiScanner,eax


    	cmp byte ptr DebugModeTxt,"0"
	je initdone
	invoke SetTextColor, DARK_GREEN
	print "Debug: Read "
	invoke StdOut,ADDR INI_Path
	invoke StdOut,ADDR CRLF ; print " ",10,13

initdone:
	clc    ;Clear Carry flag to indicate no errors
	ret
GetSettingsFromIni endp

;------------------------------------------------------------------------------------------------
; Get a command from INI file

GetFromIni proc near lpCmd:DWORD, lpDefault:DWORD, lpDest:DWORD, DestSize:DWORD

; This stub calls GetPrivateProfileString in Kernel32.dll

	invoke GetPrivateProfileString, ADDR IniSectionName, lpCmd, lpDefault, lpDest, DestSize, INI_ADDR
	ret
GetFromIni endp


;------------------------------------------------------------------------------------------------
; Get the Application Path

GetAppPath proc near lpPathBuffer:DWORD

	invoke GetModuleFileName,0,lpPathBuffer,128  ; return length in eax
	add eax, lpPathBuffer         ; Search from end to start
findslash:
	dec eax                        
	cmp BYTE PTR [eax],"\"  	; find the last "\"
	jne  findslash
	mov  BYTE PTR [eax+1],0		; write zero terminator after "\"
	;mov  eax, lpPathBuffer
	ret
GetAppPath endp


;------------------------------------------------------------------------------------------------
; Initialize Console
;
; Returns with: EBX = X-console width
;               ECX = Y-console height (currently disabled)
;InitConsole proc near
;
;
;	invoke GetConsoleWindow
;	mov    hWnd,eax 
;
;	Invoke SetConsoleTitle, ADDR Net2BBSTitle              ; Set Window Title
;	invoke FindWindow,ADDR ClassName, Addr Net2BBSTitle    ; Find Window handle matching this class/title
;
;
;;invoke CreateConsoleScreenBuffer,GENERIC_READ OR GENERIC_WRITE,0,0,CONSOLE_TEXTMODE_BUFFER,0
;
;; There is no need to change the input
;;	invoke GetStdHandle,STD_INPUT_HANDLE
;;	mov hStdIn, eax
;;	invoke SetConsoleMode, hStdIn, ENABLE_PROCESSED_INPUT
;
;
;; But we must define the output
;	invoke GetStdHandle,STD_OUTPUT_HANDLE
;	mov   hStdOut,eax
;
; ;InitClear:
; ;	cls		  ; Clear the screen via MASM32
; ;	invoke FillConsoleOutputAttribute,hStdOut,00,80*25,NULL,ADDR temp   ; Force the screen to clear black
; ;	invoke GetConsoleScreenBufferInfo,hStdOut,ADDR csbi
; ;	movzx ebx,csbi.dwSize.x
; ;	mov   console_X_size,ebx
; ;	movzx ecx,csbi.swSize.y
; ;	mov   console_Y_size,ecx
; ;	mov dx,csbi.dwCursorPosition.y ; Get 'y' Cursor position.
;
;      ;cls ; clear screen
;      ret
;      
;InitConsole endp

;------------------------------------------------------------------------------------------------
; Convert Double-Word to ASCII string
;
; dwValue is passed as a value, direct, indirect or in register
; lpBuffer is the ADDRESS of the receiving buffer
; Returns with eax= number of characters written to buffer (zero=error).
;
; EXAMPLE:
; invoke dw2a,edx,ADDR buffer


dw2a proc near dwValue:DWORD, lpBuffer:DWORD
	invoke wsprintfA,lpBuffer,ADDR fMtString,dwValue
	ret
dw2a endp


;------------------------------------------------------------------------------------------------
; This ReadLine procedure was taken from the MASM32 library and modified to prevent line buffer
; overflow.  It is used to process the killfile list of bocked IP's and hostnames.

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4
ReadLine proc source:DWORD,buffer:DWORD,spos:DWORD

comment * ------------------------------------------------------

        source  =   source memory to read line from
        buffer  =   buffer that line of text is written to
        spos    =   start position in buffer to write to

        readline copies a line of text from the source
        to the buffer starting from the offset set in "spos",
        updates the "spos" variable to the start of the following
        line of text and returns that variable in EAX.
        EAX returns ZERO if the end of the source is on the
        curent line.

        The length of the line not including ascii
        0 and 13 is returned in ECX. You should test
        the buffer if ZERO is returned in EAX as it may
        contain the last line of text that is zero terminated.

        Conditions to test for.
        1. End of source returns zero in EAX.
        2. blank line has 1st byte in buffer set to zero
           and a line length in ECX of ZERO.
        3. Line length is returned in ECX.

        ------------------------------------------------------ *

	push edi
    mov edx, [esp+8]            ; source address in EDX
    mov edi, [esp+12]           ; buffer address in EDI
    add edx, [esp+16]           ; add spos to source
    xor eax, eax                ; clear EAX
    mov ecx, -1                 ; set index and counter to -1
    jmp short ristart

	align 4
 	pre:
  ;---------- buffer overflow pcm fix 1
  cmp ecx,128
  ja ristart
  ;----------
    mov [edi+ecx], al           ; write BYTE to buffer
  ristart:
    add ecx, 1
    mov al, [edx+ecx]           ; read BYTE from source
    cmp al, 9                   ; handle TAB character
    je pre
    cmp al, 13                  ; test for ascii 13 and 0
    ja pre
    ;---------- buffer overflow pcm fix 2
    mov edx,128
    cmp ecx,edx
    jb termit
    mov ecx,edx
   ;----------

termit:
    mov BYTE PTR [edi+ecx], 0   ; write terminator to buffer
    test eax, eax               ; test for end of source
    jz liout                    ; return zero if end of source
    lea eax, [ecx+2]            ; add counter + 2 to EAX
    add eax, [esp+16]           ; return next spos in eax

  liout:
    pop edi
    ret 12

ReadLine endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef



;------------------------------------------------------------------------------------------------
; The procedures below this line were found in public forums and may or may not be public domain!
;------------------------------------------------------------------------------------------------


;------------------------------------------------------------------------------------------------
SetTextColor proc near foreback16:BYTE ;was fore:DWORD,back:DWORD

; 
; This proc sets the foreground and background attributes for
; the characters written to the console screen buffer.
;
; The color values are normal 4-bit IRGB character mode
; attributes where:
;   bit3 = intensity
;   bit2 = red
;   bit1 = green
;   bit0 = blue
; 
; The attribute is stored in a single byte (contained in a dword).
	;mov   eax,back
	;shl   eax,4
	;or	  eax,fore

      movzx eax,foreback16
      mov MailSlotColor,al ; Save the current color for the mailslot
	invoke SetConsoleTextAttribute,hStdOut,eax
	ret
SetTextColor endp


;------------------------------------------------------------------------------------------------
; Replace - Text String Search and Replace Function
;
align 4

Replace proc near src:DWORD,dst:DWORD,txt1:DWORD,txt2:DWORD

;  Source String, Dest String, orig text, new text
    LOCAL lsrc	:DWORD

;	push ebx
;	push esi
;	push edi
	cld				; Clear direction flag	(needed for stosb)		
	mov lsrc, len(src)	; procedure call for src length
	sub lsrc, len(txt1) 	; procedure call for 1st text length

	mov esi, src
	add lsrc, esi		; set exit condition
	mov ebx, txt1
	inc lsrc			; adjust to get last character
	mov edi, dst
	xor eax, eax		; zero EAX
	dec esi
	jmp short rpst
; ----------------------------
  align 4
pre:
    add esi, ecx		; ecx = len of txt1, add it to ESI for next read
rpst:
	inc esi
	cmp lsrc, esi		; test for exit condition
	jle rpout
	mov al, [esi]		; load byte from source
	mov ah,al
	or ah,020h
	cmp ah, [ebx]		; test it against 1st character in txt1
	je test_match
	stosb				; write byte to destination (same as mov [edi],al - inc edi) 
	jmp short rpst
; ----------------------------
  align 4
test_match:
	mov edx, ebx		; load txt1 address into EDX
	xor ecx,ecx 		; clear ECX to use as index
@@:
	mov al, [edx]
	test al, al 		; if you have got to the zero
	jz change_text		; replace the text in the destination
;    cmp [esi+ecx], al		; keep testing character matches
	mov ah, [esi+ecx]
	or ah,020h			; convert to lower case
	inc edx
	inc ecx
	cmp ah,al
	je @B
	mov al, [esi]		; if text does not match
	stosb				; write byte at ESI to DSI (destination)
	jmp short rpst
; ----------------------------
  align 4
change_text:			; write txt2 to location of txt1 in destination
	mov edx, txt2
	dec ecx
@@:
	mov al, [edx]
	test al, al
	jz pre
	inc edx
	stosb
	jmp short @B
; ----------------------------
  align 4
rpout:				; write any last bytes and terminator
	xor ecx,ecx
@@:
	mov al, [esi+ecx]
	mov [edi+ecx], al
      inc ecx
	test al, al
	jnz @B
;	pop edi
;	pop esi
;	pop ebx
	ret
Replace endp


;------------------------------------------------------------------------------------------------
; WildMatch - Checks if one string exists within another string, supporting wildcards "?" and "*".
; Returns with ZF=off if match (JNZ MATCH)

  align 4

WildMatch proc near wild :DWORD, string :DWORD ;uses ebx ecx edx esi edi

    mov        ecx, wild
    mov        edx, string

    .while BYTE PTR [edx] != 0 && BYTE PTR [ecx] != "*"
	mov	   bl, [ecx]
	mov	   bh, [edx]
	.if bl != bh && bl != "?"
          xor        eax, eax ; no match = zero on
	    ret
	.endif
	inc	   ecx
	inc	   edx
    .endw

    .while BYTE PTR [edx] != 0
	mov	   bl, [ecx]
	mov	   bh, [edx]
	.if bl == "*"
	    inc        ecx
	    mov        bl, [ecx]
	    .if bl == 0
		;xor	   eax, eax
		;inc	   eax
		inc      ebx
		ret ; match, return with zero flag off!
	    .endif
	    mov        eax, edx
	    mov        esi, ecx
	    inc        eax
	.elseif bl == bh || bl == "?"
	    inc        ecx
	    inc        edx
	.else
	    mov        edx, eax
	    mov        ecx, esi
	    inc        eax
	.endif
    .endw
    
    .while    BYTE PTR [ecx] == "*"
	inc	   ecx
    .endw

 	sete byte ptr [ecx] ; Set Zero Flag to 1 if zero
    	ret

WildMatch endp

end start
